//=============================================================================
//
// file :        PLCesall.h
//
// description : Include for the PLCesall class.
//
// project :	plc vacuum low level configurable sever
//
// $Author: graziano $
//
// $Revision: 1.21 $
//
// $Log: PLCesall.h,v $
// Revision 1.21  2019-05-02 13:49:39  graziano
// fixed
//
// Revision 1.20  2019-05-02 13:45:09  graziano
// added SET/UNSET ccd_pos_tmra
//
// Revision 1.19  2019-04-29 13:44:32  graziano
// fixed
//
// Revision 1.18  2018-07-24 13:03:34  graziano
// new padres valves
//
// Revision 1.17  2018-04-27 20:24:04  graziano
// added vlvt_pfe_04 open and close commands
//
// Revision 1.16  2018-04-06 15:23:44  graziano
// renamed for unification FEL1 and FEL2, inserted new ppm1.05
//
// Revision 1.15  2017-10-06 08:11:31  graziano
// changed magnedyn command code from 808 to 909
//
// Revision 1.14  2017-08-21 08:28:37  graziano
// tango 9.2.5a
//
// Revision 1.13  2016-12-22 11:15:33  graziano
// added sh_pos.01
//
// Revision 1.12  2015-06-04 13:02:55  graziano
// fixed size
//
// Revision 1.11  2015-06-03 15:20:11  graziano
// fixed
//
// Revision 1.10  2015-06-03 15:16:24  graziano
// added timer
//
// Revision 1.9  2013-01-07 10:42:35  graziano
// added command to set vacuum interlock threshold
//
// Revision 1.8  2012-10-01 09:16:08  graziano
// added commands for PPM1 and PPM2
//
// Revision 1.7  2012-02-09 10:57:17  graziano
// updated for gas padres
//
// Revision 1.6  2012-01-16 10:34:48  graziano
// modified gas padres
//
// Revision 1.5  2011/07/04 08:13:41  graziano
// fixed for new valves
//
// Revision 1.4  2011/04/22 08:25:36  graziano
// updated mysql log
//
// Revision 1.3  2010/12/03 14:59:02  graziano
// new log message queue,
// improved startup time,
// added shutter
//
// Revision 1.2  2010/11/24 08:46:26  graziano
// development
//
// Revision 1.1  2010/11/23 11:01:23  graziano
// development
//
//
//
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _PLCESALL_H
#define _PLCESALL_H

#include <tango.h>
#include <math.h>
#include <mysql.h>
#include <deque>
#include <stdint.h>
//using namespace Tango;

#pragma pack(1)

/**
 * @author	$Author: graziano $
 * @version	$Revision: 1.21 $
 */

 //	Add your own constants definitions here.
 //-----------------------------------------------
//size of the message buffer
#define	BUF_LEN	4000


#define	DB50_DATA_SIZE		278		//db50 = 10 header + 242
#define	DB53_DATA_SIZE		DB50_DATA_SIZE
#define DB54_DATA_SIZE		128		//db54 = 10 header + TODO
#define DB55_DATA_SIZE		64		//db55 = 10 header + 64 float


#define	MESG_STAT_SYS_LEN	DB50_DATA_SIZE*8
//size of db in bit
#define	MESG_ALM_SYS_LEN	DB53_DATA_SIZE*8
//size of db in bit
#define	MESG_OUT_SYS_LEN	DB54_DATA_SIZE*8
//size of db in bit
//#define	MESG_REAL_SYS_LEN	DB55_DATA_SIZE*4*8
#define	MESG_REAL_SYS_LEN	DB55_DATA_SIZE
//size of db in bit
//#define	MESG_CMD	1904	

#define	MAX_N_ATTR	10	//max number of spectrum attributes
#define MAX_ALL   2500 		//max len of a spectrum attributes
#define	MAX_LEN_LABEL	128 //34
#define	MAX_LEN_DESC	128 //60

#define	ECHO_MESG_STAT_SYS_CMD	50
#define	ECHO_MESG_ALM_SYS_CMD	53
#define	ECHO_MESG_OUT_SYS_CMD	54
#define	OPN_CLS_CMD_FEL1		101	//open/close commands fel1
#define	OPN_CLS_CMD_FEL2		202	//open/close commands fel2
#define	OPN_CLS_CMD_POS			707	//open/close commands pos/tmr valves
#define	OPN_CLS_CMD_MAG			909	//open/close commands mag valves
#define PMP_VEL_CMD_FEL1			303	//ppm1 rotation speed commands fel1
#define PMP_VEL_CMD_FEL2			404	//ppm1 rotation speed commands fel2
#define	PPM_START_STOP_CMD_FEL1		505	//ppm1 start/stop commands fel1
#define	PPM_START_STOP_CMD_FEL2		606	//ppm1 start/stop commands fel2
#define	SET_PERCENT_INTLK_THRESH	808	//set % for interlock threshold
#define	ACK_CMD					102	//acknowledge
#define	OPN_CLS_CMD_FEL		9988	//open/close commands fel1

#define FELCMDCODES			5	//101, 202, 707, 909, 808: logged commands

#define	SYNC_CODE				7777	//command code for recall clock syncronization
/*#define	SHUTTER_CMD				99	//command code for recall clock syncronization

#define MPS_SHUTTER_OPEN		0	//bit position in intlck_cmd.shutter_cmds
#define MPS_SHUTTER_CLOSE		1	//bit position in intlck_cmd.shutter_cmds
*/
#define ID_PLC_LINAC	0
#define ID_PLC_UH	1
#define ID_PLC_PADRES	2

//max size of the db query
//#define	DB_QUERY_LEN	1024
#define	DB_QUERY_LEN	1900

#define L_ALARM		1 //logtype alarm
#define L_CMD		2 //logtype beam dump
#define L_SRVSTART	3 //logtype server restart
#define L_ACK		4 //logtype ack
#define L_UPDATE	6 //update description
#define L_EXIT		7 //exit thread
#define L_ALARM_RT	8 //logtype alarm

//types of alarm log message
#define M_ALARM		0 //a new alarm
#define M_ACK		1 //sent ack from server
#define M_SRVSTART	2 //server restarted
#define M_STATE		3 //state message
#define M_DETALARM	4 //alarm detail
#define M_DETRESTORE	5 //restore detail
#define M_DETALARM_RT	6 //alarm detail
#define M_DETRESTORE_RT	7 //restore detail
#define M_COMMAND	8 //sent command

//alarm log message
#define S_ALARM		"ALARM" //a new alarm
#define S_RESTORE	"NORMAL" //alarm detail
#define S_ACK		"ACKNOWLEDGE" //sent ack from server
#define S_SRVSTART	"SRV_RESTART" //server restarted
#define S_COMMAND	"COMMAND" //sent cmd



#define	START_PPM1_PFE_FEL12_01   0	//START PPM1_PFE_F01_01,PPM1_PFE_F02_01
#define	START_PPM1_PFE_FEL12_02   1	//START PPM1_PFE_F01_02,PPM1_PFE_F02_02
#define	START_PPM1_PFE_FEL12_03   2	//START PPM1_PFE_F01_03,PPM1_PFE_F02_03
#define	START_PPM1_PFE_FEL12_04   3	//START PPM1_PFE_F01_04,PPM1_PFE_F02_04
#define	START_PPM1_PFE_FEL12_05   4	//START PPM1_PFE_F01_05,PPM1_PFE_F02_05
#define	START_PPM1_PFE_FEL12_06   5	//START PPM1_PFE_F01_06,PPM1_PFE_F02_06
#define	START_PPM1_PFE_FEL12_07   6	//START PPM1_PFE_F01_07,PPM1_PFE_F02_07
#define	START_PPM1_PFE_FEL12_08   7	//START PPM1_PFE_F01_08,PPM1_PFE_F02_08
#define CMD_OPN_VLV_PFE_F0102_01	8
#define CMD_CLD_VLV_PFE_F0102_01	9
#define CMD_OPN_VLV_PFE_F0102_02	10
#define CMD_CLD_VLV_PFE_F0102_02	11
#define CMD_OPN_VLV_PFE_F0102_03	12
#define CMD_CLD_VLV_PFE_F0102_03	13
#define CMD_OPN_VLVT_PFE_F0102_01	14
#define CMD_CLD_VLVT_PFE_F0102_01	15
#define CMD_OPN_VLV_PFE_F0102_04	16
#define CMD_CLD_VLV_PFE_F0102_04	17
#define CMOPN_VLVG_IO_PFE_F0102_01	18	//_F02 /con 707 CMD_OPN_VLV_POS_TMR_03
#define CMCLD_VLVG_IO_PFE_F0102_01	19	//_F02 /con 707 CMD_CLD_VLV_POS_TMR_03
#define CM_OP_VLVT_IO_PFE_F0102_01	20	//_F02 /con 707 CMD_OPN_VLV_POS_LDM_01
#define CM_CL_VLVT_IO_PFE_F0102_01	21	//_F02 /con 707 CMD_CLD_VLV_POS_LDM_01
#define CMD_OPN_VLV_PFE_F0102_05	22	//_F02 /con 707 CMD_OPN_VLV_POS_TMX_01
#define CMD_CLD_VLV_PFE_F0102_05	23	//_F02 /con 707 CMD_CLD_VLV_POS_TMX_01
#define CMD_OPN_VLVT_PFE_F0102_02	24	//_F02 /con 707 CMD_OPN_VLV_POS_DPI_01
#define CMD_CLD_VLVT_PFE_F0102_02	25	//_F02 /con 707 CMD_CLD_VLV_POS_DPI_01
#define CMD_OPN_VLVT_PFE_F0102_03	26	//_F02 /con 707 CMD_OPN_VLV_POS_LDM_02
#define CMD_CLD_VLVT_PFE_F0102_03	27	//_F02 /con 707 CMD_CLD_VLV_POS_LDM_02
#define CMD_OPN_VLV_PFE_F0102_06	28	//_F02 /con 707 CMD_OPN_VLV_POS_LDM_03
#define CMD_CLD_VLV_PFE_F0102_06	29	//_F02 /con 707 CMD_CLD_VLV_POS_LDM_03
#define CMD_OPN_VLVT_PFE_F0102_04	30	//_F02 /con 707 CMD_OPN_VLV_POS_TMX_02
#define CMD_CLD_VLVT_PFE_F0102_04	31	//_F02 /con 707 CMD_CLD_VLV_POS_TMX_02
#define CMD_OPN_VLVG_PFE_01	32			//con 202 CMD_OPN_VLVHP_G1_PFE_01 /con 707 CMD_OPN_VLV_POS_TMX_03
#define CMD_CLD_VLVG_PFE_01	33			//con 202 CMD_CLD_VLVHP_G1_PFE_01 /con 707 CMD_CLD_VLV_POS_TMX_03
#define CMD_OPN_VLVG_IO_PFE_02	34		//con 202 CMD_OPN_VLVG_PFE_F02_01 /con 707 CMD_OPN_VLV_POS_DPI_02
#define CMD_CLD_VLVG_IO_PFE_02	35		//con 202 CMD_CLD_VLVG_PFE_F02_01 /con 707 CMD_CLD_VLV_POS_DPI_02
#define CMD_OPN_VLVG_IO_PFE_01	36		//con 202 CMD_CLD_VLVHP_G2_PFE_01 /con 707 CMD_OPN_VLV_POS_DPI_03
#define CMD_CLD_VLVG_IO_PFE_01	37		//con 202 CMD_CLD_VLVHP_G2_PFE_01 /con 707 CMD_CLD_VLV_POS_DPI_03
#define CMD_OPN_VLVIO_G1_PFE_01 	38	//con 202 CMD_OPN_VLVHP_G3_PFE_01 /con 707 CMD_OPN_VLV_POS_DPI_04
#define CMD_CLD_VLVIO_G1_PFE_01 	39	//con 202 CMD_CLD_VLVHP_G3_PFE_01 /con 707 CMD_CLD_VLV_POS_DPI_04
#define CMD_OPN_VLVG_G1_PFE_01 	40		//con 202 CMD_OPN_VLVHP_G4_PFE_01
#define CMD_CLD_VLVG_G1_PFE_01 	41		//con 202 CMD_CLD_VLVHP_G4_PFE_01
#define CMD_OPN_VLVG_G2_PFE_01 	42		//con 202 CMD_OPN_VLV_IO_G3_PFE_01
#define CMD_CLD_VLVG_G2_PFE_01 	43		//con 202 CMD_CLD_VLV_IO_G3_PFE_01
#define CMD_OPN_VLVG_G3_PFE_01   44//CMD_OPN_VLV_POS_01
#define CMD_CLD_VLVG_G3_PFE_01   45//CMD_CLD_VLV_POS_01
#define CMD_OPN_VLVG_G4_PFE_01   46//CMD_OPN_VLV_POS_02
#define CMD_CLD_VLVG_G4_PFE_01   47//CMD_CLD_VLV_POS_02
#define CMD_OPN_VLVIO_G2_PFE_01   48	//con 202 CMD_OPN_VLV_IO_G4_PFE_01
#define CMD_CLD_VLVIO_G2_PFE_01   49	//con 202 CMD_CLD_VLV_IO_G4_PFE_01
#define CMD_OPN_VLV_PFE_F0102_07 	50
#define CMD_CLD_VLV_PFE_F0102_07 	51
#define CMD_OPN_VLVT_PFE_F0102_05	52
#define CMD_CLD_VLVT_PFE_F0102_05	53
#define CMD_OPN_VLVT_PFE_F0102_06	54
#define CMD_CLD_VLVT_PFE_F0102_06	55
#define CMD_OPN_VLV_PFE_F0102_08 	56
#define CMD_CLD_VLV_PFE_F0102_08 	57
#define CMOPN_VLVG_IO_PFE_F0102_02	58
#define CMCLD_VLVG_IO_PFE_F0102_02	59
#define CM_OP_VLVT_IO_PFE_F0102_02	60
#define CM_CL_VLVT_IO_PFE_F0102_02	61
#define CMD_OPN_VLV_PFE_F0102_09 	62
#define CMD_CLD_VLV_PFE_F0102_09 	63
#define CMD_OPN_VLVT_PFE_F0102_07	64
#define CMD_CLD_VLVT_PFE_F0102_07	65
#define CMD_OPN_VLV_PFE_F0102_10 	66
#define CMD_CLD_VLV_PFE_F0102_10 	67
#define CMD_OPN_VLV_POS_F0102_01 	68
#define CMD_CLD_VLV_POS_F0102_01 	69
#define CMD_OPN_VLV_POS_F0102_02 	70
#define CMD_CLD_VLV_POS_F0102_02 	71
#define CMD_OPN_SH_PFE_F0102_02 	72
#define CMD_SET_PERCENT_INTLK_THRESH 	72
#define CMD_CLD_SH_PFE_F0102_02 	73
#define CMD_OPN_VLVG_PFE_F01_01		74
#define CMD_CLD_VLVG_PFE_F01_01		75

#define	PPM1_60HZ_PFE_FEL12_01   76	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 60Hz            /con 9988 CMD_OPN_VLVT_PFE_01 2.0
#define	PPM1_70HZ_PFE_FEL12_01   77	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 70Hz            /con 9988 CMD_CLD_VLVT_PFE_01 2.1
#define	PPM1_80HZ_PFE_FEL12_01   78	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 80Hz            /con 9988 CMD_OPN_VLVT_IO_PFE_01 2.2
#define	PPM1_90HZ_PFE_FEL12_01   79	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 90Hz            /con 9988 CMD_CLD_VLVT_IO_PFE_01 2.3
#define	PPM1_95HZ_PFE_FEL12_01   80	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 95Hz            /con 9988 CMD_OPN_VLVT_PFE_02 2.4
#define	PPM1_100HZ_PFE_FEL12_01   81	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 100Hz       /con 9988 CMD_CLD_VLVT_PFE_02 2.5
#define	PPM1_60HZ_PFE_FEL12_02   82	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 60Hz            /con 9988 CMD_OPN_VLVT_PFE_03 2.6
#define	PPM1_70HZ_PFE_FEL12_02   83	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 70Hz            /con 9988 CMD_CLD_VLVT_PFE_03 2.7
#define	PPM1_80HZ_PFE_FEL12_02   84	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 80Hz            /con 9988 CMD_OPN_VLVT_PFE_04 3.0
#define	PPM1_90HZ_PFE_FEL12_02   85	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 90Hz            /con 9988 CMD_CLD_VLVT_PFE_04 3.1
#define	PPM1_95HZ_PFE_FEL12_02   86	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 95Hz            /con 9988 CMD_OPN_VLVT_PFE_05 3.2
#define	PPM1_100HZ_PFE_FEL12_02   87	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 100Hz       /con 9988 CMD_CLD_VLVT_PFE_05 3.3
#define	PPM1_60HZ_PFE_FEL12_03   88	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 60Hz            /con 9988 CMD_OPN_VLVT_PFE_06 3.4
#define	PPM1_70HZ_PFE_FEL12_03   89	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 70Hz            /con 9988 CMD_CLD_VLVT_PFE_06 3.5
#define	PPM1_80HZ_PFE_FEL12_03   90	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 80Hz            /con 9988 CMD_OPN_VLVT_IO_PFE_02 3.6
#define	PPM1_90HZ_PFE_FEL12_03   91	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 90Hz            /con 9988 CMD_CLD_VLVT_IO_PFE_02 3.7
#define	PPM1_95HZ_PFE_FEL12_03   92	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 95Hz            /con 9988 CMD_OPN_VLVT_PFE_07 4.0
#define	PPM1_100HZ_PFE_FEL12_03   93	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 100Hz       /con 9988 CMD_CLD_VLVT_PFE_07 4.1
#define	PPM1_60HZ_PFE_FEL12_04   94	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 60Hz
#define	PPM1_70HZ_PFE_FEL12_04   95	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 70Hz
#define	PPM1_80HZ_PFE_FEL12_04   96	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 80Hz
#define	PPM1_90HZ_PFE_FEL12_04   97	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 90Hz
#define	PPM1_95HZ_PFE_FEL12_04   98	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 95Hz
#define	PPM1_100HZ_PFE_FEL12_04   99	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 100Hz
#define	PPM1_60HZ_PFE_FEL12_05   100	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 60Hz
#define	PPM1_70HZ_PFE_FEL12_05   101	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 70Hz
#define	PPM1_80HZ_PFE_FEL12_05   102	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 80Hz
#define	PPM1_90HZ_PFE_FEL12_05   103	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 90Hz
#define	PPM1_95HZ_PFE_FEL12_05   104	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 95Hz
#define	PPM1_100HZ_PFE_FEL12_05   105	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 100Hz
#define	PPM1_60HZ_PFE_FEL12_06   106	//PPM1_PFE_F01_05,PPM1_PFE_F02_06 60Hz
#define	PPM1_70HZ_PFE_FEL12_06   107	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 70Hz
#define	PPM1_80HZ_PFE_FEL12_06   108	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 80Hz
#define	PPM1_90HZ_PFE_FEL12_06   109	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 90Hz
#define	PPM1_95HZ_PFE_FEL12_06   110	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 95Hz
#define	PPM1_100HZ_PFE_FEL12_06   111	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 100Hz
#define	PPM1_60HZ_PFE_FEL12_07   112	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 60Hz
#define	PPM1_70HZ_PFE_FEL12_07   113	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 70Hz
#define	PPM1_80HZ_PFE_FEL12_07   114	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 80Hz
#define	PPM1_90HZ_PFE_FEL12_07   115	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 90Hz
#define	PPM1_95HZ_PFE_FEL12_07   116	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 95Hz
#define	PPM1_100HZ_PFE_FEL12_07   117	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 100Hz
#define	PPM1_60HZ_PFE_FEL12_08   118	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 60Hz
#define	PPM1_70HZ_PFE_FEL12_08   119	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 70Hz
#define	PPM1_80HZ_PFE_FEL12_08   120	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 80Hz
#define	PPM1_90HZ_PFE_FEL12_08   121	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 90Hz
#define	PPM1_95HZ_PFE_FEL12_08   122	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 95Hz
#define	PPM1_100HZ_PFE_FEL12_08   123	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 100Hz

#define	STOP_PPM1_PFE_FEL12_01   124	//STOP PPM1_PFE_F01_01,PPM1_PFE_F02_01
#define	STOP_PPM1_PFE_FEL12_02   125	//STOP PPM1_PFE_F01_02,PPM1_PFE_F02_02
#define	STOP_PPM1_PFE_FEL12_03   126	//STOP PPM1_PFE_F01_03,PPM1_PFE_F02_03
#define	STOP_PPM1_PFE_FEL12_04   127	//STOP PPM1_PFE_F01_04,PPM1_PFE_F02_04
#define	STOP_PPM1_PFE_FEL12_05   128	//STOP PPM1_PFE_F01_05,PPM1_PFE_F02_05
#define	STOP_PPM1_PFE_FEL12_06   129	//STOP PPM1_PFE_F01_06,PPM1_PFE_F02_06
#define	STOP_PPM1_PFE_FEL12_07   130	//STOP PPM1_PFE_F01_07,PPM1_PFE_F02_07
#define	STOP_PPM1_PFE_FEL12_08   131	//STOP PPM1_PFE_F01_08,PPM1_PFE_F02_08
#define	CMD_OPN_VLV_POS_TMRA_06   132	//
#define	CMD_CLD_VLV_POS_TMRA_06   133	//STOP PPM1_PFE_F01_08,PPM1_PFE_F02_08
#define	CMD_OPN_SH_POS_01   134	//
#define	CMD_CLD_SH_POS_01   135	//STOP PPM1_PFE_F01_08,PPM1_PFE_F02_08

#define	CMD_SET_CCD_POS_TMRA_01    136	//SET CCD_POS_TMRA_01
#define	CMD_UNSET_CCD_POS_TMRA_01    137	//UNSET CCD_POS_TMRA_01
#define	CMD_SET_CCD_POS_TMRA_03    138	//SET CCD_POS_TMRA_03
#define	CMD_UNSET_CCD_POS_TMRA_03    139	//UNSET CCD_POS_TMRA_03

#define	CMD_ABI_TMP300_PFE_F01_01    140	//CMD_ABI_TMP300_PFE_F02_01
#define	CMD_NOTABI_TMP300_PFE_F01_01    141	//CMD_NOTABI_TMP300_PFE_F02_01
#define	CMD_ABI_TMP80_PFE_F01_01    142	//CMD_ABI_TMP80_PFE_F02_01
#define	CMD_NOTABI_TMP80_PFE_F01_01    143	//CMD_NOTABI_TMP80_PFE_F02_01
#define	CMD_ABI_TMP500_PFE_F01_01    144	//CMD_ABI_TMP500_PFE_F02_01
#define	CMD_NOTABI_TMP500_PFE_F01_01    145	//CMD_NOTABI_TMP500_PFE_F02_01
#define	CMD_ABI_TMP500_PFE_F01_02    146	//CMD_ABI_TMP500_PFE_F02_02
#define	CMD_NOTABI_TMP500_PFE_F01_02    147	//CMD_NOTABI_TMP500_PFE_F02_02
#define	CMD_LASER_POINTER_ACDC_ON   148	
#define	CMD_LASER_POINTER_ACDC_OFF    149	

#define MAX_COMMAND 				CMD_LASER_POINTER_ACDC_OFF


static int blkcodes[] = {	//byte offset from actDB
6,	//START_PPM1_PFE_FEL12_01	0
6,	//START_PPM1_PFE_FEL12_02   1
6,	//START_PPM1_PFE_FEL12_03   2
6,	//START_PPM1_PFE_FEL12_04   3
6,	//START_PPM1_PFE_FEL12_05    4
6,	//START_PPM1_PFE_FEL12_06    5
6,	//START_PPM1_PFE_FEL12_07   6		//con 303 CMD_ABI_TMP300_PFE_F01_01 con 404 CMD_ABI_TMP300_PFE_F02_01
6,	//START_PPM1_PFE_FEL12_08   7		//con 303 CMD_NOTABI_TMP300_PFE_F01_01 con 404 CMD_NOTABI_TMP300_PFE_F02_01
8,	//CMD_OPN_VLV_PFE_F0102_01	8	//CMD_OPN_VLV_POS_03
8,	//CMD_CLD_VLV_PFE_F0102_01	9	//CMD_CLD_VLV_POS_03
8,	//CMD_OPN_VLV_PFE_F0102_02	10	//CMD_OPN_VLV_POS_04
8,	//CMD_CLD_VLV_PFE_F0102_02	11	//CMD_CLD_VLV_POS_04
8,	//CMD_OPN_VLV_PFE_F0102_03	12	//CMD_OPN_VLV_POS_05
8,	//CMD_CLD_VLV_PFE_F0102_03	13	//CMD_CLD_VLV_POS_05
8,	//CMD_OPN_VLVT_PFE_F0102_01	14	//CMD_OPN_VLV_POS_TMR_01
8,	//CMD_CLD_VLVT_PFE_F0102_01	15	//CMD_CLD_VLV_POS_TMR_01
9,	//CMD_OPN_VLV_PFE_F0102_04	16	//CMD_OPN_VLV_POS_TMR_02
9,	//CMD_CLD_VLV_PFE_F0102_04	17	//CMD_CLD_VLV_POS_TMR_02
9,	//CMOPN_VLVG_IO_PFE_F0102_01	18	//CMD_OPN_VLV_POS_TMR_03
9,	//CMCLD_VLVG_IO_PFE_F0102_01	19	//CMD_CLD_VLV_POS_TMR_03
9,	//CM_OP_VLVT_IO_PFE_F0102_01	20	//CMD_OPN_VLV_POS_LDM_01
9,	//CM_CL_VLVT_IO_PFE_F0102_01	21	//CMD_CLD_VLV_POS_LDM_01
9,	//CMD_OPN_VLV_PFE_F0102_05	22	//CMD_OPN_VLV_POS_TMX_01
9,	//CMD_CLD_VLV_PFE_F0102_05	23	//CMD_CLD_VLV_POS_TMX_01
10,	//CMD_OPN_VLVT_PFE_F0102_02	24	//CMD_OPN_VLV_POS_DPI_01
10,	//CMD_CLD_VLVT_PFE_F0102_02	25	//CMD_CLD_VLV_POS_DPI_01
10,	//CMD_OPN_VLVT_PFE_F0102_03	26	//CMD_OPN_VLV_POS_LDM_02
10,	//CMD_CLD_VLVT_PFE_F0102_03	27	//CMD_CLD_VLV_POS_LDM_02
10,	//CMD_OPN_VLV_PFE_F0102_06	28	//CMD_OPN_VLV_POS_LDM_03
10,	//CMD_CLD_VLV_PFE_F0102_06	29	//CMD_CLD_VLV_POS_LDM_03
10,	//CMD_OPN_VLVT_PFE_F0102_04	30	//CMD_OPN_VLV_POS_TMX_02
10,	//CMD_CLD_VLVT_PFE_F0102_04	31	//CMD_CLD_VLV_POS_TMX_02
11,	//CMD_OPN_VLVG_PFE_01	32	//con 202 CMD_OPN_VLVHP_G1_PFE_01 /con 707 CMD_OPN_VLV_POS_TMX_03
11,	//CMD_CLD_VLVG_PFE_01	33			//con 202 CMD_CLD_VLVHP_G1_PFE_01 /con 707 CMD_CLD_VLV_POS_TMX_03
11,	//CMD_OPN_VLVG_IO_PFE_02	34		//con 202 CMD_OPN_VLVG_PFE_F02_01 /con 707 CMD_OPN_VLV_POS_DPI_02
11,	//CMD_CLD_VLVG_IO_PFE_02	35		//con 202 CMD_CLD_VLVG_PFE_F02_01 /con 707 CMD_CLD_VLV_POS_DPI_02
11,	//CMD_OPN_VLVG_IO_PFE_01	36		//con 202 CMD_CLD_VLVHP_G2_PFE_01 /con 707 CMD_OPN_VLV_POS_DPI_03
11,	//CMD_CLD_VLVG_IO_PFE_01	37		//con 202 CMD_CLD_VLVHP_G2_PFE_01 /con 707 CMD_CLD_VLV_POS_DPI_03
11,	//CMD_OPN_VLVIO_G1_PFE_01 	38		//con 202 CMD_OPN_VLVHP_G3_PFE_01 /con 707 CMD_OPN_VLV_POS_DPI_04
11,	//CMD_CLD_VLVIO_G1_PFE_01 	39		//con 202 CMD_CLD_VLVHP_G3_PFE_01 /con 707 CMD_CLD_VLV_POS_DPI_04
12,	//CMD_OPN_VLVG_G1_PFE_01 	40		//con 202 CMD_OPN_VLVHP_G4_PFE_01 /con 707 CMD_OPN_VLV_POS_TMR_04
12,	//CMD_CLD_VLVG_G1_PFE_01 	41		//con 202 CMD_CLD_VLVHP_G4_PFE_01 /con 707 CMD_CLD_VLV_POS_TMR_04
12,	//CMD_OPN_VLVG_G2_PFE_01 	42		//con 202 CMD_OPN_VLV_IO_G3_PFE_01 /con 707 CMD_OPN_VLV_POS_TMR_05
12,	//CMD_CLD_VLVG_G2_PFE_01 	43		//con 202 CMD_CLD_VLV_IO_G3_PFE_01 /con 707 CMD_CLD_VLV_POS_TMR_05
12,	//CMD_OPN_VLVG_G3_PFE_01   44		//con 202 CMD_OPN_VLV_POS_01 /con 707 CMD_OPN_VLV_POS_TMR_06
12,	//CMD_CLD_VLVG_G3_PFE_01   45		//con 202 CMD_CLD_VLV_POS_01 /con 707 CMD_CLD_VLV_POS_TMR_06
12,	//CMD_OPN_VLVG_G4_PFE_01   46		//con 202 CMD_OPN_VLV_POS_02 /con 707 CMD_OPN_VLV_POS_TMR_07
12,	//CMD_CLD_VLVG_G4_PFE_01   47		//con 202 CMD_CLD_VLV_POS_02 /con 707 CMD_CLD_VLV_POS_TMR_07
13,	//CMD_OPN_VLVIO_G2_PFE_01   48		//con 202 CMD_OPN_VLV_IO_G4_PFE_01 /con 707 CMD_OPN_VLV_POS_TMR_08
13,	//CMD_CLD_VLVIO_G2_PFE_01   49		//con 202 CMD_CLD_VLV_IO_G4_PFE_01 /con 707 CMD_CLD_VLV_POS_TMR_08
13,	//CMD_OPN_VLV_PFE_F0102_07 	50		//_F02 /con 707 CMD_OPN_VLV_POS_TMR_09
13,	//CMD_CLD_VLV_PFE_F0102_07 	51		//_F02 /con 707 CMD_CLD_VLV_POS_TMR_09
13,	//CMD_OPN_VLVT_PFE_F0102_05	52		//_F02 /con 707 CMD_OPN_VLV_POS_TMRB_01
13,	//CMD_CLD_VLVT_PFE_F0102_05	53		//_F02 /con 707 CMD_CLD_VLV_POS_TMRB_01
13,	//CMD_OPN_VLVT_PFE_F0102_06	54		//_F02 /con 707 CMD_OPN_VLV_POS_TMRB_02
13,	//CMD_CLD_VLVT_PFE_F0102_06	55		//_F02 /con 707 CMD_CLD_VLV_POS_TMRB_02
14,	//CMD_OPN_VLV_PFE_F0102_08 	56		//_F02 /con 707 CMD_OPN_VLV_POS_TMRB_03 /con 808 CMD_OPN_VLV_POS_MAG_01
14,	//CMD_CLD_VLV_PFE_F0102_08 	57		//_F02 /con 707 CMD_CLD_VLV_POS_TMRB_03 /con 808 CMD_CLD_VLV_POS_MAG_01
14,	//CMOPN_VLVG_IO_PFE_F0102_02	58	//_F02 /con 707 CMD_OPN_VLV_POS_TMRB_04 /con 808 CMD_OPN_VLV_POS_MAG_02
14,	//CMCLD_VLVG_IO_PFE_F0102_02	59	//_F02 /con 707 CMD_CLD_VLV_POS_TMRB_04 /con 808 CMD_CLD_VLV_POS_MAG_02
14,	//CM_OP_VLVT_IO_PFE_F0102_02	60	//_F02 /con 707 CMD_OPN_VLV_POS_TMRB_05 /con 808 CMD_OPN_VLV_POS_MAG_03
14,	//CM_CL_VLVT_IO_PFE_F0102_02	61	//_F02 /con 707 CMD_CLD_VLV_POS_TMRB_05 /con 808 CMD_CLD_VLV_POS_MAG_03
14,	//CMD_OPN_VLV_PFE_F0102_09 	62		//_F02 /con 707 CMD_OPN_VLV_POS_TMRB_06 /con 808 CMD_OPN_VLV_POS_MAG_04
14,	//CMD_CLD_VLV_PFE_F0102_09 	63		//_F02 /con 707 CMD_CLD_VLV_POS_TMRB_06 /con 808 CMD_CLD_VLV_POS_MAG_04
15,	//CMD_OPN_VLVT_PFE_F0102_07	64		//_F02 /con 707 CMD_OPN_VLV_POS_TMRB_07 /con 808 CMD_OPN_VLV_POS_MAG_05
15,	//CMD_CLD_VLVT_PFE_F0102_07	65		//_F02 /con 707 CMD_CLD_VLV_POS_TMRB_07 /con 808 CMD_CLD_VLV_POS_MAG_05
15,	//CMD_OPN_VLV_PFE_F0102_10 	66		//_F02 /con 707 CMD_OPN_VLV_POS_TMRA_01 /con 808 CMD_OPN_VLV_POS_MAG_06
15,	//CMD_CLD_VLV_PFE_F0102_10 	67		//_F02 /con 707 CMD_CLD_VLV_POS_TMRA_01 /con 808 CMD_CLD_VLV_POS_MAG_06
15,	//CMD_OPN_VLV_POS_F0102_01 	68		//_F02 /con 707 CMD_OPN_VLV_POS_TMRA_02 /con 808 CMD_OPN_VLV_POS_MAG_07
15,	//CMD_CLD_VLV_POS_F0102_01 	69		//_F02 /con 707 CMD_CLD_VLV_POS_TMRA_02 /con 808 CMD_CLD_VLV_POS_MAG_07
15,	//CMD_OPN_VLV_POS_F0102_02 	70		//_F02 /con 707 CMD_OPN_VLV_POS_TMRA_03 /con 808 CMD_OPN_VLV_POS_MAG_08
15,	//CMD_CLD_VLV_POS_F0102_02 	71		//_F02 /con 707 CMD_CLD_VLV_POS_TMRA_03 /con 808 CMD_CLD_VLV_POS_MAG_08
16,	//CMD_OPN_SH_PFE_F0102_02 	72		//_F02 /con 808 set % allarme /con 707 CMD_OPN_VLV_POS_TMRA_04
16,	//CMD_CLD_SH_PFE_F0102_02 	73		//_F02 /con 707 CMD_CLD_VLV_POS_TMRA_04
16,	//CMD_OPN_VLVG_PFE_F01_01		74		//_F02 /con 707 CMD_OPN_VLV_POS_TMRA_05
16,	//CMD_CLD_VLVG_PFE_F01_01		75		//_F02 /con 707 CMD_CLD_VLV_POS_TMRA_05
0,	//   76	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 60Hz   /con 9988 CMD_OPN_VLVT_PFE_01 2.0
0,	//   77	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 70Hz   /con 9988 CMD_CLD_VLVT_PFE_01 2.1
0,	//   78	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 80Hz   /con 9988 CMD_OPN_VLVT_IO_PFE_01 2.2
0,	//   79	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 90Hz   /con 9988 CMD_CLD_VLVT_IO_PFE_01 2.3
0,	//   80	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 95Hz   /con 9988 CMD_OPN_VLVT_PFE_02 2.4
0,	//   81	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 100Hz  /con 9988 CMD_CLD_VLVT_PFE_02 2.5
0,	//   82	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 60Hz   /con 9988 CMD_OPN_VLVT_PFE_03 2.6
0,	//   83	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 70Hz   /con 9988 CMD_CLD_VLVT_PFE_03 2.7
1,	//   84	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 80Hz   /con 9988 CMD_OPN_VLVT_PFE_04 3.0
1,	//   85	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 90Hz   /con 9988 CMD_CLD_VLVT_PFE_04 3.1
1,	//   86	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 95Hz   /con 9988 CMD_OPN_VLVT_PFE_05 3.2
1,	//   87	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 100Hz  /con 9988 CMD_CLD_VLVT_PFE_05 3.3
1,	//   88	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 60Hz   /con 9988 CMD_OPN_VLVT_PFE_06 3.4
1,	//   89	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 70Hz   /con 9988 CMD_CLD_VLVT_PFE_06 3.5
1,	//   90	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 80Hz   /con 9988 CMD_OPN_VLVT_IO_PFE_02 3.6
1,	//   91	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 90Hz   /con 9988 CMD_CLD_VLVT_IO_PFE_02 3.7
2,	//   92	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 95Hz   /con 9988 CMD_OPN_VLVT_PFE_07 4.0
2,	//   93	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 100Hz  /con 9988 CMD_CLD_VLVT_PFE_07 4.1
2,	//   94	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 60Hz
2,	//   95	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 70Hz
2,	//   96	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 80Hz
2,	//   97	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 90Hz
2,	//   98	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 95Hz
2,	//   99	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 100Hz
3,	//   100	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 60Hz
3,	//   101	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 70Hz
3,	//   102	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 80Hz
3,	//   103	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 90Hz
3,	//   104	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 95Hz
3,	//   105	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 100Hz
3,	//   106	//PPM1_PFE_F01_05,PPM1_PFE_F02_06 60Hz
3,	//   107	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 70Hz
4,	//   108	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 80Hz
4,	//   109	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 90Hz
4,	//   110	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 95Hz
4,	//   111	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 100Hz
4,	//   112	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 60Hz
4,	//   113	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 70Hz
4,	//   114	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 80Hz
4,	//   115	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 90Hz
5,	//   116	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 95Hz
5,	//   117	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 100Hz
5,	//   118	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 60Hz
5,	//   119	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 70Hz
5,	//   120	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 80Hz
5,	//   121	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 90Hz
5,	//   122	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 95Hz
5,	//   123	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 100Hz
7,	//   124	//STOP PPM1_PFE_F01_01,PPM1_PFE_F02_01
7,	//   125	//STOP PPM1_PFE_F01_02,PPM1_PFE_F02_02
7,	//   126	//STOP PPM1_PFE_F01_03,PPM1_PFE_F02_03
7,	//   127	//STOP PPM1_PFE_F01_04,PPM1_PFE_F02_04
7,	//   128	//STOP PPM1_PFE_F01_05,PPM1_PFE_F02_05
7,	//   129	//STOP PPM1_PFE_F01_06,PPM1_PFE_F02_06
7,	//   130	//STOP PPM1_PFE_F01_07,PPM1_PFE_F02_07  /con 303 CMD_ON_LASER_POINER_TMR DB61.DBX9.6
7,	//   131	//STOP PPM1_PFE_F01_08,PPM1_PFE_F02_08  /con 303 CMD_OFF_LASER_POINER_TMR DB61.DBX9.7
16,	//   132	///con 707 CMD_OPN_VLV_POS_TMRA_06
16,	//   133	///con 707 CMD_CLD_VLV_POS_TMRA_06
16,	//   134	///con 707 CMD_OPN_SH_POS_01
16,	//   135	///con 707 CMD_CLD_SH_POS_01
17,	//   136	///con 707 SET CCD_POS_TMRA_01
17,	//   137	///con 707 UNSET CCD_POS_TMRA_01
17,	//   138	///con 707 SET CCD_POS_TMRA_03
17,	//   139	///con 707 UNSET CCD_POS_TMRA_03
6,	//   140	//con 303 CMD_ABI_TMP300_PFE_F01_01 /con 404 CMD_ABI_TMP300_PFE_F02_01 //8.6
6,	//   141	//con 303 CMD_NOTABI_TMP300_PFE_F01_01 /con 404 CMD_NOTABI_TMP300_PFE_F02_01 //8.7
7,	//   142	//con 303 CMD_ABI_TMP80_PFE_F01_01 /con 404 CMD_ABI_TMP80_PFE_F02_01 //9.0
7,	//   143	//con 303 CMD_NOTABI_TMP80_PFE_F01_01 /con 404 CMD_NOTABI_TMP80_PFE_F02_01 //9.1
7,	//   144	//con 303 CMD_ABI_TMP500_PFE_F01_01 /con 404 CMD_ABI_TMP500_PFE_F02_01 //9.2
7,	//   145	//con 303 CMD_NOTABI_TMP500_PFE_F01_01 /con 404 CMD_NOTABI_TMP500_PFE_F02_01 //9.3
7,	//   146	//con 303 CMD_ABI_TMP500_PFE_F01_02 /con 404 CMD_ABI_TMP500_PFE_F02_02 //9.4
7,	//   147	//con 303 CMD_NOTABI_TMP500_PFE_F01_02 /con 404 CMD_NOTABI_TMP500_PFE_F02_02 //9.5
8,	//   148	//con 303 CMD_LASER_POINTER_ACDC_ON	
8	//   149	//con 303 CMD_LASER_POINTER_ACDC_OFF	
};

static u_int maskcodes[] = {
0x01,	//START_PPM1_PFE_FEL12_01	0
0x02,	//START_PPM1_PFE_FEL12_02   1
0x04,	//START_PPM1_PFE_FEL12_03   2
0x08,	//START_PPM1_PFE_FEL12_04   3
0x10,	//START_PPM1_PFE_FEL12_05    4
0x20,	//START_PPM1_PFE_FEL12_06    5
0x40,	//START_PPM1_PFE_FEL12_07   6		//con 303 CMD_ABI_TMP300_PFE_F01_01
0x80,	//START_PPM1_PFE_FEL12_08   7		//con 303 CMD_NOTABI_TMP300_PFE_F01_01
0x01,	//CMD_OPN_VLV_PFE_F0102_01	8	//CMD_OPN_VLV_POS_03
0x02,	//CMD_CLD_VLV_PFE_F0102_01	9	//CMD_CLD_VLV_POS_03
0x04,	//CMD_OPN_VLV_PFE_F0102_02	10	//CMD_OPN_VLV_POS_04
0x08,	//CMD_CLD_VLV_PFE_F0102_02	11	//CMD_CLD_VLV_POS_04
0x10,	//CMD_OPN_VLV_PFE_F0102_03	12	//CMD_OPN_VLV_POS_05
0x20,	//CMD_CLD_VLV_PFE_F0102_03	13	//CMD_CLD_VLV_POS_05
0x40,	//CMD_OPN_VLVT_PFE_F0102_01	14	//CMD_OPN_VLV_POS_TMR_01
0x80,	//CMD_CLD_VLVT_PFE_F0102_01	15	//CMD_CLD_VLV_POS_TMR_01
0x01,	//CMD_OPN_VLV_PFE_F0102_04	16	//CMD_OPN_VLV_POS_TMR_02
0x02,	//CMD_CLD_VLV_PFE_F0102_04	17	//CMD_CLD_VLV_POS_TMR_02
0x04,	//CMOPN_VLVG_IO_PFE_F0102_01	18	//CMD_OPN_VLV_POS_TMR_03
0x08,	//CMCLD_VLVG_IO_PFE_F0102_01	19	//CMD_CLD_VLV_POS_TMR_03
0x10,	//CM_OP_VLVT_IO_PFE_F0102_01	20	//CMD_OPN_VLV_POS_LDM_01
0x20,	//CM_CL_VLVT_IO_PFE_F0102_01	21	//CMD_CLD_VLV_POS_LDM_01
0x40,	//CMD_OPN_VLV_PFE_F0102_05	22	//CMD_OPN_VLV_POS_TMX_01
0x80,	//CMD_CLD_VLV_PFE_F0102_05	23	//CMD_CLD_VLV_POS_TMX_01
0x01,	//CMD_OPN_VLVT_PFE_F0102_02	24	//CMD_OPN_VLV_POS_DPI_01
0x02,	//CMD_CLD_VLVT_PFE_F0102_02	25	//CMD_CLD_VLV_POS_DPI_01
0x04,	//CMD_OPN_VLVT_PFE_F0102_03	26	//CMD_OPN_VLV_POS_LDM_02
0x08,	//CMD_CLD_VLVT_PFE_F0102_03	27	//CMD_CLD_VLV_POS_LDM_02
0x10,	//CMD_OPN_VLV_PFE_F0102_06	28	//CMD_OPN_VLV_POS_LDM_03
0x20,	//CMD_CLD_VLV_PFE_F0102_06	29	//CMD_CLD_VLV_POS_LDM_03
0x40,	//CMD_OPN_VLVT_PFE_F0102_04	30	//CMD_OPN_VLV_POS_TMX_02
0x80,	//CMD_CLD_VLVT_PFE_F0102_04	31	//CMD_CLD_VLV_POS_TMX_02
0x01,	//CMD_OPN_VLVG_PFE_01	32			//con 202 CMD_OPN_VLVHP_G1_PFE_01 /con 707 CMD_OPN_VLV_POS_TMX_03
0x02,	//CMD_CLD_VLVG_PFE_01	33			//con 202 CMD_CLD_VLVHP_G1_PFE_01 /con 707 CMD_CLD_VLV_POS_TMX_03
0x04,	//CMD_OPN_VLVG_IO_PFE_02	34		//con 202 CMD_OPN_VLVG_PFE_F02_01 /con 707 CMD_OPN_VLV_POS_DPI_02
0x08,	//CMD_CLD_VLVG_IO_PFE_02	35		//con 202 CMD_CLD_VLVG_PFE_F02_01 /con 707 CMD_CLD_VLV_POS_DPI_02
0x10,	//CMD_OPN_VLVG_IO_PFE_01	36		//con 202 CMD_CLD_VLVHP_G2_PFE_01 /con 707 CMD_OPN_VLV_POS_DPI_03
0x20,	//CMD_CLD_VLVG_IO_PFE_01	37		//con 202 CMD_CLD_VLVHP_G2_PFE_01 /con 707 CMD_CLD_VLV_POS_DPI_03
0x40,	//CMD_OPN_VLVIO_G1_PFE_01 	38	//con 202 CMD_OPN_VLVHP_G3_PFE_01 /con 707 CMD_OPN_VLV_POS_DPI_04
0x80,	//CMD_CLD_VLVIO_G1_PFE_01 	39	//con 202 CMD_CLD_VLVHP_G3_PFE_01 /con 707 CMD_CLD_VLV_POS_DPI_04
0x01,	//CMD_OPN_VLVG_G1_PFE_01 	40		//con 202 CMD_OPN_VLVHP_G4_PFE_01
0x02,	//CMD_CLD_VLVG_G1_PFE_01 	41		//con 202 CMD_CLD_VLVHP_G4_PFE_01
0x04,	//CMD_OPN_VLVG_G2_PFE_01 	42		//con 202 CMD_OPN_VLV_IO_G3_PFE_01
0x08,	//CMD_CLD_VLVG_G2_PFE_01 	43		//con 202 CMD_CLD_VLV_IO_G3_PFE_01
0x10,	//CMD_OPN_VLVG_G3_PFE_01   44//CMD_OPN_VLV_POS_01
0x20,	//CMD_CLD_VLVG_G3_PFE_01   45//CMD_CLD_VLV_POS_01
0x40,	//CMD_OPN_VLVG_G4_PFE_01   46//CMD_OPN_VLV_POS_02
0x80,	//CMD_CLD_VLVG_G4_PFE_01   47//CMD_CLD_VLV_POS_02
0x01,	//CMD_OPN_VLVIO_G2_PFE_01   48	//con 202 CMD_OPN_VLV_IO_G4_PFE_01
0x02,	//CMD_CLD_VLVIO_G2_PFE_01   49	//con 202 CMD_CLD_VLV_IO_G4_PFE_01
0x04,	//CMD_OPN_VLV_PFE_F0102_07 	50
0x08,	//CMD_CLD_VLV_PFE_F0102_07 	51
0x10,	//CMD_OPN_VLVT_PFE_F0102_05	52
0x20,	//CMD_CLD_VLVT_PFE_F0102_05	53
0x40,	//CMD_OPN_VLVT_PFE_F0102_06	54
0x80,	//CMD_CLD_VLVT_PFE_F0102_06	55
0x01,	//CMD_OPN_VLV_PFE_F0102_08 	56
0x02,	//CMD_CLD_VLV_PFE_F0102_08 	57
0x04,	//CMOPN_VLVG_IO_PFE_F0102_02	58
0x08,	//CMCLD_VLVG_IO_PFE_F0102_02	59
0x10,	//CM_OP_VLVT_IO_PFE_F0102_02	60
0x20,	//CM_CL_VLVT_IO_PFE_F0102_02	61
0x40,	//CMD_OPN_VLV_PFE_F0102_09 	62
0x80,	//CMD_CLD_VLV_PFE_F0102_09 	63
0x01,	//CMD_OPN_VLVT_PFE_F0102_07	64
0x02,	//CMD_CLD_VLVT_PFE_F0102_07	65
0x04,	//CMD_OPN_VLV_PFE_F0102_10 	66
0x08,	//CMD_CLD_VLV_PFE_F0102_10 	67
0x10,	//CMD_OPN_VLV_POS_F0102_01 	68
0x20,	//CMD_CLD_VLV_POS_F0102_01 	69
0x40,	//CMD_OPN_VLV_POS_F0102_02 	70
0x80,	//CMD_CLD_VLV_POS_F0102_02 	71
0x01,	//CMD_OPN_SH_PFE_F0102_02	72
0x02,	//CMD_CLD_SH_PFE_F0102_02	73
0x04,	//CMD_OPN_VLVG_PFE_F01_01		74
0x08,	//CMD_CLD_VLVG_PFE_F01_01		75
0x01,	//   76	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 60Hz//START_PPM1_PFE_FEL12_01	0      /con 9988 CMD_OPN_VLVT_PFE_01 2.0           
0x02,	//   77	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 70Hz//START_PPM1_PFE_FEL12_02   1    /con 9988 CMD_CLD_VLVT_PFE_01 2.1           
0x04,	//   78	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 80Hz//START_PPM1_PFE_FEL12_03   2    /con 9988 CMD_OPN_VLVT_IO_PFE_01 2.2           
0x08,	//   79	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 90Hz//START_PPM1_PFE_FEL12_04   3    /con 9988 CMD_CLD_VLVT_IO_PFE_01 2.3           
0x10,	//   80	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 95Hz//START_PPM1_PFE_FEL12_05    4   /con 9988 CMD_OPN_VLVT_PFE_02 2.4           
0x20,	//   81	//PPM1_PFE_F01_01,PPM1_PFE_F02_01 100Hz//START_PPM1_PFE_FEL12_06    5  /con 9988 CMD_CLD_VLVT_PFE_02 2.5           
0x40,	//   82	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 60Hz//START_PPM1_PFE_FEL12_07   6    /con 9988 CMD_OPN_VLVT_PFE_03 2.6           
0x80,	//   83	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 70Hz//START_PPM1_PFE_FEL12_08   7    /con 9988 CMD_CLD_VLVT_PFE_03 2.7           
0x01,	//   84	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 80Hz//START_PPM1_PFE_FEL12_01	0      /con 9988 CMD_OPN_VLVT_PFE_04 3.0           
0x02,	//   85	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 90Hz//START_PPM1_PFE_FEL12_02   1    /con 9988 CMD_CLD_VLVT_PFE_04 3.1           
0x04,	//   86	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 95Hz//START_PPM1_PFE_FEL12_03   2    /con 9988 CMD_OPN_VLVT_PFE_05 3.2           
0x08,	//   87	//PPM1_PFE_F01_02,PPM1_PFE_F02_02 100Hz//START_PPM1_PFE_FEL12_04   3   /con 9988 CMD_CLD_VLVT_PFE_05 3.3           
0x10,	//   86	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 60Hz//START_PPM1_PFE_FEL12_05    4   /con 9988 CMD_OPN_VLVT_PFE_06 3.4           
0x20,	//   89	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 70Hz//START_PPM1_PFE_FEL12_06    5   /con 9988 CMD_CLD_VLVT_PFE_06 3.5           
0x40,	//   90	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 80Hz//START_PPM1_PFE_FEL12_07   6    /con 9988 CMD_OPN_VLVT_IO_PFE_02 3.6           
0x80,	//   91	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 90Hz//START_PPM1_PFE_FEL12_08   7    /con 9988 CMD_CLD_VLVT_IO_PFE_02 3.7           
0x01,	//   92	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 95Hz//START_PPM1_PFE_FEL12_01	0      /con 9988 CMD_OPN_VLVT_PFE_07 4.0           
0x02,	//   93	//PPM1_PFE_F01_03,PPM1_PFE_F02_03 100Hz//START_PPM1_PFE_FEL12_02   1   /con 9988 CMD_CLD_VLVT_PFE_07 4.1           
0x04,	//   94	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 60Hz//START_PPM1_PFE_FEL12_03   2
0x08,	//   95	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 70Hz//START_PPM1_PFE_FEL12_04   3
0x10,	//   96	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 80Hz//START_PPM1_PFE_FEL12_05    4
0x20,	//   97	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 90Hz//START_PPM1_PFE_FEL12_06    5
0x40,	//   98	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 95Hz//START_PPM1_PFE_FEL12_07   6
0x80,	//   99	//PPM1_PFE_F01_04,PPM1_PFE_F02_04 100Hz//START_PPM1_PFE_FEL12_08   7
0x01,	//   100	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 60Hz//START_PPM1_PFE_FEL12_01	0
0x02,	//   101	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 70Hz//START_PPM1_PFE_FEL12_02   1
0x04,	//   102	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 80Hz//START_PPM1_PFE_FEL12_03   2
0x08,	//   103	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 90Hz//START_PPM1_PFE_FEL12_04   3
0x10,	//   104	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 95Hz//START_PPM1_PFE_FEL12_05    4
0x20,	//   105	//PPM1_PFE_F01_05,PPM1_PFE_F02_05 100Hz//START_PPM1_PFE_FEL12_06    5
0x40,	//   106	//PPM1_PFE_F01_05,PPM1_PFE_F02_06 60Hz//START_PPM1_PFE_FEL12_07   6
0x80,	//   107	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 70Hz//START_PPM1_PFE_FEL12_08   7
0x01,	//   108	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 80Hz//START_PPM1_PFE_FEL12_01	0
0x02,	//   109	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 90Hz//START_PPM1_PFE_FEL12_02   1
0x04,	//   110	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 95Hz//START_PPM1_PFE_FEL12_03   2
0x08,	//   111	//PPM1_PFE_F01_06,PPM1_PFE_F02_06 100Hz//START_PPM1_PFE_FEL12_04   3
0x10,	//   112	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 60Hz//START_PPM1_PFE_FEL12_05    4
0x20,	//   113	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 70Hz//START_PPM1_PFE_FEL12_06    5
0x40,	//   114	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 80Hz//START_PPM1_PFE_FEL12_07   6
0x80,	//   115	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 90Hz//START_PPM1_PFE_FEL12_08   7
0x01,	//   116	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 95Hz//START_PPM1_PFE_FEL12_01	0
0x02,	//   117	//PPM1_PFE_F01_07,PPM1_PFE_F02_07 100Hz//START_PPM1_PFE_FEL12_02   1
0x04,	//   118	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 60Hz//START_PPM1_PFE_FEL12_03   2
0x08,	//   119	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 70Hz//START_PPM1_PFE_FEL12_04   3
0x10,	//   120	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 80Hz//START_PPM1_PFE_FEL12_05    4
0x20,	//   121	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 90Hz//START_PPM1_PFE_FEL12_06    5
0x40,	//   122	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 95Hz//START_PPM1_PFE_FEL12_07   6
0x80,	//   123	//PPM1_PFE_F01_08,PPM1_PFE_F02_08 100Hz//START_PPM1_PFE_FEL12_08   7
0x01,	//   124	//STOP PPM1_PFE_F01_01,PPM1_PFE_F02_01//START_PPM1_PFE_FEL12_01	0
0x02,	//   125	//STOP PPM1_PFE_F01_02,PPM1_PFE_F02_02//START_PPM1_PFE_FEL12_02   1
0x04,	//   126	//STOP PPM1_PFE_F01_03,PPM1_PFE_F02_03//START_PPM1_PFE_FEL12_03   2
0x08,	//   127	//STOP PPM1_PFE_F01_04,PPM1_PFE_F02_04//START_PPM1_PFE_FEL12_04   3
0x10,	//   128	//STOP PPM1_PFE_F01_05,PPM1_PFE_F02_05//START_PPM1_PFE_FEL12_05    4
0x20,	//   129	//STOP PPM1_PFE_F01_06,PPM1_PFE_F02_06//START_PPM1_PFE_FEL12_06    5
0x40,	//   130	//STOP PPM1_PFE_F01_07,PPM1_PFE_F02_07//START_PPM1_PFE_FEL12_07   6
0x80,	//   131	//STOP PPM1_PFE_F01_08,PPM1_PFE_F02_08//START_PPM1_PFE_FEL12_08   7
0x10,	//   132	//CMD_OPN_VLV_POS_TMRA_06
0x20,	//   133	//CMD_CLD_VLV_POS_TMRA_06
0x40,	//   134	//CMD_OPN_SH_POS_01
0x80,	//   135	//CMD_CLD_SH_POS_01
0x00,	//   136	///con 707 SET CCD_POS_TMRA_01
0x01,	//   137	///con 707 UNSET CCD_POS_TMRA_01
0x02,	//   138	///con 707 SET CCD_POS_TMRA_03
0x04,	//   139	///con 707 UNSET CCD_POS_TMRA_03
0x40,	//   140	//con 303 CMD_ABI_TMP300_PFE_F01_01 /con 404 CMD_ABI_TMP300_PFE_F02_01 //8.6
0x80,	//   141	//con 303 CMD_NOTABI_TMP300_PFE_F01_01 /con 404 CMD_NOTABI_TMP300_PFE_F02_01 //8.7
0x01,	//   142	//con 303 CMD_ABI_TMP80_PFE_F01_01 /con 404 CMD_ABI_TMP80_PFE_F02_01 //9.0
0x02,	//   143	//con 303 CMD_NOTABI_TMP80_PFE_F01_01 /con 404 CMD_NOTABI_TMP80_PFE_F02_01 //9.1
0x04,	//   144	//con 303 CMD_ABI_TMP500_PFE_F01_01 /con 404 CMD_ABI_TMP500_PFE_F02_01 //9.2
0x08,	//   145	//con 303 CMD_NOTABI_TMP500_PFE_F01_01 /con 404 CMD_NOTABI_TMP500_PFE_F02_01 //9.3
0x10,	//   146	//con 303 CMD_ABI_TMP500_PFE_F01_02 /con 404 CMD_ABI_TMP500_PFE_F02_02 //9.4
0x20,	//   147	//con 303 CMD_NOTABI_TMP500_PFE_F01_02 /con 404 CMD_NOTABI_TMP500_PFE_F02_02 //9.5
0x01,	//   148	//con 303 CMD_LASER_POINTER_ACDC_ON	
0x02	//   149	//con 303 CMD_LASER_POINTER_ACDC_OFF
};    
      
static const char *cmd_names[][FELCMDCODES] = {
 {"START_PPM1_PFE_01","START_PPM1_PFE_05","","",""},	//0
 {"START_PPM1_PFE_02","START_PPM1_PFE_FEL2_02","","",""},	//1
 {"START_PPM1_PFE_03","START_PPM1_PFE_FEL2_03","","",""},	//2
 {"START_PPM1_PFE_04","START_PPM1_PFE_FEL2_04","","",""},	//3
 {"START_PPM1_PFE_06","START_PPM1_PFE_FEL2_06","","",""},	//4
 {"START_PPM1_PFE_07","START_PPM1_PFE_FEL2_07","","",""},	//5
 {"START_PPM1_PFE_08","START_PPM1_PFE_FEL2_08","","",""},	//6
 {"START_PPM1_PFE_09","START_PPM1_PFE_FEL2_09","","",""},	//7
 {"CMD_OPN_VLV_PFE_F01_01","CMD_OPN_VLV_PFE_F02_01","CMD_OPN_VLV_POS_03","",""},	//8
 {"CMD_CLD_VLV_PFE_F01_01","CMD_CLD_VLV_PFE_F02_01","CMD_CLD_VLV_POS_03","",""},	//9
 {"CMD_OPN_VLV_PFE_F01_02","CMD_OPN_VLV_PFE_F02_02","CMD_OPN_VLV_POS_04","",""},	//10
 {"CMD_CLD_VLV_PFE_F01_02","CMD_CLD_VLV_PFE_F02_02","CMD_CLD_VLV_POS_04","",""},	//11
 {"CMD_OPN_VLV_PFE_F01_03","CMD_OPN_VLV_PFE_F02_03","CMD_OPN_VLV_POS_05","",""},	//12
 {"CMD_CLD_VLV_PFE_F01_03","CMD_CLD_VLV_PFE_F02_03","CMD_CLD_VLV_POS_05","",""},	//13
 {"CMD_OPN_VLVT_PFE_F01_01","CMD_OPN_VLVT_PFE_F02_01","CMD_OPN_VLV_POS_TMR_01","",""},	//14
 {"CMD_CLD_VLVT_PFE_F01_01","CMD_CLD_VLVT_PFE_F02_01","CMD_CLD_VLV_POS_TMR_01","",""},	//15
 {"CMD_OPN_VLV_PFE_F01_04","CMD_OPN_VLV_PFE_F02_04","CMD_OPN_VLV_POS_TMR_02","",""},	//16
 {"CMD_CLD_VLV_PFE_F01_04","CMD_CLD_VLV_PFE_F02_04","CMD_CLD_VLV_POS_TMR_02","",""},	//17
 {"CMD_OPN_VLVG_IO_PFE_F01_01","CMD_OPN_VLVG_IO_PFE_F02_01","CMD_OPN_VLV_POS_TMR_03","",""},	//18
 {"CMD_CLD_VLVG_IO_PFE_F01_01","CMD_CLD_VLVG_IO_PFE_F02_01","CMD_CLD_VLV_POS_TMR_03","",""},	//19
 {"CMD_OPN_VLVT_IO_PFE_F01_01","CMD_OPN_VLVT_IO_PFE_F02_01","CMD_OPN_VLV_POS_LDM_01","",""},	//20
 {"CMD_CLD_VLVT_IO_PFE_F01_01","CMD_CLD_VLVT_IO_PFE_F02_01","CMD_CLD_VLV_POS_LDM_01","",""},	//21
 {"CMD_OPN_VLV_PFE_F01_05","CMD_OPN_VLV_PFE_F02_05","CMD_OPN_VLV_POS_TMX_01","",""},		//22
 {"CMD_CLD_VLV_PFE_F01_05","CMD_CLD_VLV_PFE_F02_05","CMD_CLD_VLV_POS_TMX_01","",""},		//23
 {"CMD_OPN_VLVT_PFE_F01_02","CMD_OPN_VLVT_PFE_F02_02","CMD_OPN_VLV_POS_DPI_01","",""},		//24
 {"CMD_CLD_VLVT_PFE_F01_02","CMD_CLD_VLVT_PFE_F02_02","CMD_CLD_VLV_POS_DPI_01","",""},		//25
 {"CMD_OPN_VLVT_PFE_F01_03","CMD_OPN_VLVT_PFE_F02_03","CMD_OPN_VLV_POS_LDM_02","",""},		//26
 {"CMD_CLD_VLVT_PFE_F01_03","CMD_CLD_VLVT_PFE_F02_03","CMD_CLD_VLV_POS_LDM_02","",""},		//27
 {"CMD_OPN_VLV_PFE_F01_06","CMD_OPN_VLV_PFE_F02_06","CMD_OPN_VLV_POS_LDM_03","",""},		//28
 {"CMD_CLD_VLV_PFE_F01_06","CMD_CLD_VLV_PFE_F02_06","CMD_CLD_VLV_POS_LDM_03","",""},		//29
 {"CMD_OPN_VLVT_PFE_F01_04","CMD_OPN_VLVT_PFE_F02_04","CMD_OPN_VLV_POS_TMX_02","",""},		//30
 {"CMD_CLD_VLVT_PFE_F01_04","CMD_CLD_VLVT_PFE_F02_04","CMD_CLD_VLV_POS_TMX_02","",""},		//31
 {"CMD_OPN_VLVG_PFE_01","CMD_OPN_VLVHP_G1_PFE_01","CMD_OPN_VLV_POS_TMX_03","",""},		//32
 {"CMD_CLD_VLVG_PFE_01","CMD_CLD_VLVHP_G1_PFE_01","CMD_CLD_VLV_POS_TMX_03","",""},		//33
 {"CMD_OPN_VLVG_IO_PFE_02","CMD_OPN_VLVG_PFE_F02_01","CMD_OPN_VLV_POS_DPI_02","",""},		//34
 {"CMD_CLD_VLVG_IO_PFE_02","CMD_CLD_VLVG_PFE_F02_01","CMD_CLD_VLV_POS_DPI_02","",""},		//35
 {"CMD_OPN_VLVG_IO_PFE_01","CMD_CLD_VLVHP_G2_PFE_01","CMD_OPN_VLV_POS_DPI_03","",""},		//36
 {"CMD_CLD_VLVG_IO_PFE_01","CMD_CLD_VLVHP_G2_PFE_01","CMD_CLD_VLV_POS_DPI_03","",""},		//37
 {"CMD_OPN_VLVIO_G1_PFE_01","CMD_OPN_VLVHP_G3_PFE_01","CMD_OPN_VLV_POS_DPI_04","",""},		//38
 {"CMD_CLD_VLVIO_G1_PFE_01","CMD_CLD_VLVHP_G3_PFE_01","CMD_CLD_VLV_POS_DPI_04","",""},		//39
 {"CMD_OPN_VLVG_G1_PFE_01","CMD_OPN_VLVHP_G4_PFE_01","CMD_OPN_VLV_POS_TMR_04","",""},		//40
 {"CMD_CLD_VLVG_G1_PFE_01","CMD_CLD_VLVHP_G4_PFE_01","CMD_CLD_VLV_POS_TMR_04","",""},		//41
 {"CMD_OPN_VLVG_G2_PFE_01","CMD_OPN_VLV_IO_G3_PFE_01","CMD_OPN_VLV_POS_TMR_05","",""},		//42
 {"CMD_CLD_VLVG_G2_PFE_01","CMD_CLD_VLV_IO_G3_PFE_01","CMD_CLD_VLV_POS_TMR_05","",""},		//43
 {"CMD_OPN_VLVG_G3_PFE_01","CMD_OPN_VLV_POS_01","CMD_OPN_VLV_POS_TMR_06","",""},		//44//CMD_OPN_VLV_POS_01
 {"CMD_CLD_VLVG_G3_PFE_01","CMD_CLD_VLV_POS_01","CMD_CLD_VLV_POS_TMR_06","",""},		//45//CMD_CLD_VLV_POS_01
 {"CMD_OPN_VLVG_G4_PFE_01","CMD_OPN_VLV_POS_02","CMD_OPN_VLV_POS_TMR_07","",""},		//46//CMD_OPN_VLV_POS_02
 {"CMD_CLD_VLVG_G4_PFE_01","CMD_CLD_VLV_POS_02","CMD_CLD_VLV_POS_TMR_07","",""},		//47//CMD_CLD_VLV_POS_02
 {"CMD_OPN_VLVIO_G2_PFE_01","CMD_OPN_VLV_IO_G4_PFE_01","CMD_OPN_VLV_POS_TMR_08","",""},		//48
 {"CMD_CLD_VLVIO_G2_PFE_01","CMD_CLD_VLV_IO_G4_PFE_01","CMD_CLD_VLV_POS_TMR_08","",""},		//49
 {"CMD_OPN_VLV_PFE_F01_07","CMD_OPN_VLV_PFE_F02_07","CMD_OPN_VLV_POS_TMR_09","",""},		//50
 {"CMD_CLD_VLV_PFE_F01_07","CMD_CLD_VLV_PFE_F02_07","CMD_CLD_VLV_POS_TMR_09","",""},		//51
 {"CMD_OPN_VLVT_PFE_F01_05","CMD_OPN_VLVT_PFE_F02_05","CMD_OPN_VLV_POS_TMRB_01","",""},		//52
 {"CMD_CLD_VLVT_PFE_F01_05","CMD_CLD_VLVT_PFE_F02_05","CMD_CLD_VLV_POS_TMRB_01","",""},		//53
 {"CMD_OPN_VLVT_PFE_F01_06","CMD_OPN_VLVT_PFE_F02_06","CMD_OPN_VLV_POS_TMRB_02","",""},		//54
 {"CMD_CLD_VLVT_PFE_F01_06","CMD_CLD_VLVT_PFE_F02_06","CMD_CLD_VLV_POS_TMRB_02","",""},		//55
 {"CMD_OPN_VLV_PFE_F01_08","CMD_OPN_VLV_PFE_F02_08","CMD_OPN_VLV_POS_TMRB_03","CMD_OPN_VLV_POS_MAG_01",""},		//56
 {"CMD_CLD_VLV_PFE_F01_08","CMD_CLD_VLV_PFE_F02_08","CMD_CLD_VLV_POS_TMRB_03","CMD_CLD_VLV_POS_MAG_01",""},		//57
 {"CMD_OPN_VLVG_IO_PFE_F01_02","CMD_OPN_VLVG_IO_PFE_F02_02","CMD_OPN_VLV_POS_TMRB_04","CMD_OPN_VLV_POS_MAG_02",""},		//58
 {"CMD_CLD_VLVG_IO_PFE_F01_02","CMD_CLD_VLVG_IO_PFE_F02_02","CMD_CLD_VLV_POS_TMRB_04","CMD_CLD_VLV_POS_MAG_02",""},		//59
 {"CMD_OPN_VLVT_IO_PFE_F01_02","CMD_OPN_VLVT_IO_PFE_F02_02","CMD_OPN_VLV_POS_TMRB_05","CMD_OPN_VLV_POS_MAG_03",""},		//60
 {"CMD_CLD_VLVT_IO_PFE_F01_02","CMD_CLD_VLVT_IO_PFE_F02_02","CMD_CLD_VLV_POS_TMRB_05","CMD_CLD_VLV_POS_MAG_03",""},		//61
 {"CMD_OPN_VLV_PFE_F01_09","CMD_OPN_VLV_PFE_F02_09","CMD_OPN_VLV_POS_TMRB_06","CMD_OPN_VLV_POS_MAG_04",""},		//62
 {"CMD_CLD_VLV_PFE_F01_09","CMD_CLD_VLV_PFE_F02_09","CMD_CLD_VLV_POS_TMRB_06","CMD_CLD_VLV_POS_MAG_04",""},		//63
 {"CMD_OPN_VLVT_PFE_F01_07","CMD_OPN_VLVT_PFE_F02_07","CMD_OPN_VLV_POS_TMRB_07","CMD_OPN_VLV_POS_MAG_05",""},		//64
 {"CMD_CLD_VLVT_PFE_F01_07","CMD_CLD_VLVT_PFE_F02_07","CMD_CLD_VLV_POS_TMRB_07","CMD_CLD_VLV_POS_MAG_05",""},		//65
 {"CMD_OPN_VLV_PFE_F01_10","CMD_OPN_VLV_PFE_F02_10","CMD_OPN_VLV_POS_TMRA_01","CMD_OPN_VLV_POS_MAG_06",""},		//66
 {"CMD_CLD_VLV_PFE_F01_10","CMD_CLD_VLV_PFE_F02_10","CMD_CLD_VLV_POS_TMRA_01","CMD_CLD_VLV_POS_MAG_06",""},		//67
 {"CMD_OPN_VLV_POS_F01_01","CMD_OPN_VLV_POS_F02_01","CMD_OPN_VLV_POS_TMRA_02","CMD_OPN_VLV_POS_MAG_07",""},		//68
 {"CMD_CLD_VLV_POS_F01_01","CMD_CLD_VLV_POS_F02_01","CMD_CLD_VLV_POS_TMRA_02","CMD_CLD_VLV_POS_MAG_07",""},		//69
 {"CMD_OPN_VLV_POS_F01_02","CMD_OPN_VLV_POS_F02_02","CMD_OPN_VLV_POS_TMRA_03","CMD_OPN_VLV_POS_MAG_08",""},		//70
 {"CMD_CLD_VLV_POS_F01_02","CMD_CLD_VLV_POS_F02_02","CMD_CLD_VLV_POS_TMRA_03","CMD_CLD_VLV_POS_MAG_08",""},		//71
 {"CMD_OPN_SH_PFE_F01_02","CMD_OPN_SH_PFE_F02_02","CMD_OPN_VLV_POS_TMRA_04","","SET_%_ALLARME"},			//72
 {"CMD_CLD_SH_PFE_F01_02","CMD_CLD_SH_PFE_F02_02","CMD_CLD_VLV_POS_TMRA_04","",""},			//73
 {"CMD_OPN_VLVG_PFE_F01_01","","CMD_OPN_VLV_POS_TMRA_05","",""},			//74
 {"CMD_CLD_VLVG_PFE_F01_01","","CMD_CLD_VLV_POS_TMRA_05","",""},			//75
 {"PPM1_60HZ_PFE_01","PPM1_60HZ_PFE_05","","","CMD_OPN_VLVT_PFE_01"},	//76
 {"PPM1_70HZ_PFE_01","PPM1_70HZ_PFE_05","","","CMD_CLD_VLVT_PFE_01"},	//77
 {"PPM1_80HZ_PFE_01","PPM1_80HZ_PFE_05","","","CMD_OPN_VLVT_IO_PFE_01"},	//78
 {"PPM1_90HZ_PFE_01","PPM1_90HZ_PFE_05","","","CMD_CLD_VLVT_IO_PFE_01"},	//79
 {"PPM1_95HZ_PFE_01","PPM1_95HZ_PFE_05","","","CMD_OPN_VLVT_PFE_02"},	//80
 {"PPM1_100HZ_PFE_01","PPM1_100HZ_PFE_05","","","CMD_CLD_VLVT_PFE_02"},	//81
 {"PPM1_60HZ_PFE_02","PPM1_60HZ_PFE_FEL2_02","","","CMD_OPN_VLVT_PFE_03"},	//82
 {"PPM1_70HZ_PFE_02","PPM1_70HZ_PFE_FEL2_02","","","CMD_CLD_VLVT_PFE_03"},	//83
 {"PPM1_80HZ_PFE_02","PPM1_80HZ_PFE_FEL2_02","","","CMD_OPN_VLVT_PFE_04"},	//84
 {"PPM1_90HZ_PFE_02","PPM1_90HZ_PFE_FEL2_02","","","CMD_CLD_VLVT_PFE_04"},	//85
 {"PPM1_95HZ_PFE_02","PPM1_95HZ_PFE_FEL2_02","","","CMD_OPN_VLVT_PFE_05"},	//86
 {"PPM1_100HZ_PFE_02","PPM1_100HZ_PFE_FEL2_02","","","CMD_CLD_VLVT_PFE_05"},	//87
 {"PPM1_60HZ_PFE_03","PPM1_60HZ_PFE_FEL2_03","","","CMD_OPN_VLVT_PFE_06"},	//88
 {"PPM1_70HZ_PFE_03","PPM1_70HZ_PFE_FEL2_03","","","CMD_CLD_VLVT_PFE_06"},	//89
 {"PPM1_80HZ_PFE_03","PPM1_80HZ_PFE_FEL2_03","","","CMD_OPN_VLVT_IO_PFE_02"},	//90
 {"PPM1_90HZ_PFE_03","PPM1_90HZ_PFE_FEL2_03","","","CMD_CLD_VLVT_IO_PFE_02"},	//91
 {"PPM1_95HZ_PFE_03","PPM1_95HZ_PFE_FEL2_03","","","CMD_OPN_VLVT_PFE_07"},	//92
 {"PPM1_100HZ_PFE_03","PPM1_100HZ_PFE_FEL2_03","","","CMD_CLD_VLVT_PFE_07"},	//93
 {"PPM1_60HZ_PFE_04","PPM1_60HZ_PFE_FEL2_04","","",""},	//94
 {"PPM1_70HZ_PFE_04","PPM1_70HZ_PFE_FEL2_04","","",""},	//95
 {"PPM1_80HZ_PFE_04","PPM1_80HZ_PFE_FEL2_04","","",""},	//96
 {"PPM1_90HZ_PFE_04","PPM1_90HZ_PFE_FEL2_04","","",""},	//97
 {"PPM1_95HZ_PFE_04","PPM1_95HZ_PFE_FEL2_04","","",""},	//98
 {"PPM1_100HZ_PFE_04","PPM1_100HZ_PFE_FEL2_04","","",""},	//99
 {"PPM1_60HZ_PFE_06","PPM1_60HZ_PFE_FEL2_05","","",""},	//100
 {"PPM1_70HZ_PFE_06","PPM1_70HZ_PFE_FEL2_05","","",""},	//101
 {"PPM1_80HZ_PFE_06","PPM1_80HZ_PFE_FEL2_05","","",""},	//102
 {"PPM1_90HZ_PFE_06","PPM1_90HZ_PFE_FEL2_05","","",""},	//103
 {"PPM1_95HZ_PFE_06","PPM1_95HZ_PFE_FEL2_05","","",""},	//104
 {"PPM1_100HZ_PFE_06","PPM1_100HZ_PFE_FEL2_05","","",""},	//105
 {"PPM1_60HZ_PFE_07","PPM1_60HZ_PFE_FEL2_06","","",""},	//106
 {"PPM1_70HZ_PFE_07","PPM1_70HZ_PFE_FEL2_06","","",""},	//107
 {"PPM1_80HZ_PFE_07","PPM1_80HZ_PFE_FEL2_06","","",""},	//108
 {"PPM1_90HZ_PFE_07","PPM1_90HZ_PFE_FEL2_06","","",""},	//109
 {"PPM1_95HZ_PFE_07","PPM1_95HZ_PFE_FEL2_06","","",""},	//110
 {"PPM1_100HZ_PFE_07","PPM1_100HZ_PFE_FEL2_06","","",""},	//111
 {"PPM1_60HZ_PFE_08","PPM1_60HZ_PFE_FEL2_07","","",""},	//112
 {"PPM1_70HZ_PFE_08","PPM1_70HZ_PFE_FEL2_07","","",""},	//113
 {"PPM1_80HZ_PFE_08","PPM1_80HZ_PFE_FEL2_07","","",""},	//114
 {"PPM1_90HZ_PFE_08","PPM1_90HZ_PFE_FEL2_07","","",""},	//115
 {"PPM1_95HZ_PFE_08","PPM1_95HZ_PFE_FEL2_07","","",""},	//116
 {"PPM1_100HZ_PFE_08","PPM1_100HZ_PFE_FEL2_07","","",""},	//117
 {"PPM1_60HZ_PFE_09","PPM1_60HZ_PFE_FEL2_08","","",""},	//118
 {"PPM1_70HZ_PFE_09","PPM1_70HZ_PFE_FEL2_08","","",""},	//119
 {"PPM1_80HZ_PFE_09","PPM1_80HZ_PFE_FEL2_08","","",""},	//120
 {"PPM1_90HZ_PFE_09","PPM1_90HZ_PFE_FEL2_08","","",""},	//121
 {"PPM1_95HZ_PFE_09","PPM1_95HZ_PFE_FEL2_08","","",""},	//122
 {"PPM1_100HZ_PFE_09","PPM1_100HZ_PFE_FEL2_08","","",""},	//123
 {"STOP_PPM1_PFE_01","STOP_PPM1_PFE_05","","",""},	//124
 {"STOP_PPM1_PFE_02","STOP_PPM1_PFE_FEL2_02","","",""},	//125
 {"STOP_PPM1_PFE_03","STOP_PPM1_PFE_FEL2_03","","",""},	//126
 {"STOP_PPM1_PFE_04","STOP_PPM1_PFE_FEL2_04","","",""},	//127
 {"STOP_PPM1_PFE_06","STOP_PPM1_PFE_FEL2_05","","",""},	//128
 {"STOP_PPM1_PFE_07","STOP_PPM1_PFE_FEL2_06","","",""},	//129
 {"STOP_PPM1_PFE_08","STOP_PPM1_PFE_FEL2_07","","",""},	//130
 {"STOP_PPM1_PFE_09","STOP_PPM1_PFE_FEL2_08","","",""},	//131
 {"","","CMD_OPN_VLV_POS_TMRA_06","",""},	//132
 {"","","CMD_CLD_VLV_POS_TMRA_06","",""},	//133
 {"","","CMD_OPN_SH_POS_01","",""},	//134
 {"","","CMD_CLD_SH_POS_01","",""},	//135
 {"","","CMD_SET_CCD_POS_TMRA_01","",""},	//136
 {"","","CMD_UNSET_CCD_POS_TMRA_01","",""},	//137
 {"","","CMD_SET_CCD_POS_TMRA_03","",""},	//138
 {"","","CMD_UNSET_CCD_POS_TMRA_03","",""},	//139
 {"CMD_ABI_TMP300_PFE_F01_01","CMD_ABI_TMP300_PFE_F02_01","","",""},	//140
 {"CMD_NOTABI_TMP300_PFE_F01_01","CMD_NOTABI_TMP300_PFE_F02_01","","",""},	//141
 {"CMD_ABI_TMP80_PFE_F01_01","CMD_ABI_TMP80_PFE_F02_01","","",""},	//142
 {"CMD_NOTABI_TMP80_PFE_F01_01","CMD_NOTABI_TMP80_PFE_F02_01","","",""},	//143
 {"CMD_ABI_TMP500_PFE_F01_01","CMD_ABI_TMP500_PFE_F02_01","","",""},	//144
 {"CMD_NOTABI_TMP500_PFE_F01_01","CMD_NOTABI_TMP500_PFE_F02_01","","",""},	//145
 {"CMD_ABI_TMP500_PFE_F01_02","CMD_ABI_TMP500_PFE_F02_02","","",""},	//146
 {"CMD_NOTABI_TMP500_PFE_F01_02","CMD_NOTABI_TMP500_PFE_F02_02","","",""},	//147
 {"CMD_LASER_POINTER_ACDC_ON","","","",""},	//148
 {"CMD_LASER_POINTER_ACDC_OFF","","","",""}	//149
};

static const char *cmd_comments[][FELCMDCODES] = {
 {"START PPM1_PFE.01","START PPM1_PFE.05","","",""},	//0
 {"START PPM1_PFE.02","START PPM1_PFE_FEL2.02","","",""},	//1
 {"START PPM1_PFE.03","START PPM1_PFE_FEL2.03","","",""},	//2
 {"START PPM1_PFE.04","START PPM1_PFE_FEL2.04","","",""},	//3
 {"START PPM1_PFE.06","START PPM1_PFE_FEL2.05","","",""},	//4
 {"START PPM1_PFE.07","START PPM1_PFE_FEL2.06","","",""},	//5
 {"START PPM1_PFE.08","START PPM1_PFE_FEL2.07","","",""},	//6
 {"START PPM1_PFE.09","START PPM1_PFE_FEL2.08","","",""},	//7
 {"OPEN VLV_PFE_F01.01","OPEN VLV_PFE_F02.01","OPEN VLV_POS_03","",""},	//8
 {"CLOSE VLV_PFE_F01.01","CLOSE VLV_PFE_F02.01","CLOSE VLV_POS_03","",""},	//9
 {"OPEN VLV_PFE_F01.02","OPEN VLV_PFE_F02.02","OPEN VLV_POS_04","",""},	//10
 {"CLOSE VLV_PFE_F01.02","CLOSE VLV_PFE_F02.02","CLOSE VLV_POS_04","",""},	//11
 {"OPEN VLV_PFE_F01.03","OPEN VLV_PFE_F02.03","OPEN VLV_POS_05","",""},	//12
 {"CLOSE VLV_PFE_F01.03","CLOSE VLV_PFE_F02.03","CLOSE VLV_POS_05","",""},	//13
 {"OPEN VLVT_PFE_F01.01","OPEN VLVT_PFE_F02.01","OPEN VLV_POS_TMR_01","",""},	//14
 {"CLOSE VLVT_PFE_F01.01","CLOSE VLVT_PFE_F02.01","CLOSE VLV_POS_TMR_01","",""},	//15
 {"OPEN VLV_PFE_F01.04","OPEN VLV_PFE_F02.04","OPEN VLV_POS_TMR_02","",""},	//16
 {"CLOSE VLV_PFE_F01.04","CLOSE VLV_PFE_F02.04","CLOSE VLV_POS_TMR_02","",""},	//17
 {"OPEN VLVG_IO_PFE_F01.01","VLVG_IO_PFE_F02.01","OPEN VLV_POS_TMR_03","",""},	//18
 {"CLOSE VLVG_IO_PFE_F01.01","CLOSE VLVG_IO_PFE_F02.01","CLOSE VLV_POS_TMR_03","",""},	//19
 {"OPEN VLVT_IO_PFE_F01.01","OPEN VLVT_IO_PFE_F02.01","OPEN VLV_POS_LDM_01","",""},	//20
 {"CLOSE VLVT_IO_PFE_F01.01","CLOSE VLVT_IO_PFE_F02.01","CLOSE VLV_POS_LDM_01","",""},	//21
 {"OPEN VLV_PFE_F01.05","OPEN VLV_PFE_F02.05","OPEN VLV_POS_TMX_01","",""},		//22
 {"CLOSE VLV_PFE_F01.05","CLOSE VLV_PFE_F02.05","CLOSE VLV_POS_TMX_01","",""},		//23
 {"OPEN VLVT_PFE_F01.02","OPEN VLVT_PFE_F02.02","OPEN VLV_POS_DPI_01","",""},		//24
 {"CLOSE VLVT_PFE_F01.02","CLOSE VLVT_PFE_F02.02","CLOSE VLV_POS_DPI_01","",""},		//25
 {"OPEN VLVT_PFE_F01.03","OPEN VLVT_PFE_F02.03","OPEN VLV_POS_LDM_02","",""},		//26
 {"CLOSE VLVT_PFE_F01.03","CLOSE VLVT_PFE_F02.03","CLOSE VLV_POS_LDM_02","",""},		//27
 {"OPEN VLV_PFE_F01.06","OPEN VLV_PFE_F02.06","OPEN VLV_POS_LDM_03","",""},		//28
 {"CLOSE VLV_PFE_F01.06","CLOSE VLV_PFE_F02.06","CLOSE VLV_POS_LDM_03","",""},		//29
 {"OPEN VLVT_PFE_F01.04","OPEN VLVT_PFE_F02.04","OPEN VLV_POS_TMX_02","",""},		//30
 {"CLOSE VLVT_PFE_F01.04","CLOSE VLVT_PFE_F02.04","CLOSE VLV_POS_TMX_02","",""},		//31
 {"OPEN VLVG_PFE.01","OPEN VLVHP_G1_PFE.01","OPEN VLV_POS_TMX_03","",""},		//32
 {"CLOSE VLVG_PFE.01","CLOSE VLVHP_G1_PFE.01","CLOSE VLV_POS_TMX_03","",""},		//33
 {"OPEN VLVG_IO_PFE.02","OPEN VLVG_PFE_F02.01","OPEN VLV_POS_DPI_02","",""},		//34
 {"CLOSE VLVG_IO_PFE.02","CLOSE VLVG_PFE_F02.01","CLOSE VLV_POS_DPI_02","",""},		//35
 {"OPEN VLVG_IO_PFE.01","OPEN VLVHP_G2_PFE.01","OPEN VLV_POS_DPI_03","",""},		//36
 {"CLOSE VLVG_IO_PFE.01","CLOSE VLVHP_G2_PFE.01","CLOSE VLV_POS_DPI_03","",""},		//37
 {"OPEN VLVIO_G1_PFE.01","OPEN VLVHP_G3_PFE.01","OPEN VLV_POS_DPI_04","",""},		//38
 {"CLOSE VLVIO_G1_PFE.01","CLOSE VLVHP_G3_PFE.01","CLOSE VLV_POS_DPI_04","",""},		//39
 {"OPEN VLVG_G1_PFE.01","OPEN VLVHP_G4_PFE.01","OPEN VLV_POS_TMR_04","",""},			//40
 {"CLOSE VLVG_G1_PFE.01","CLOSE VLVHP_G4_PFE.01","CLOSE VLV_POS_TMR_04","",""},		//41
 {"OPEN VLVG_G2_PFE.01","OPEN VLV_IO_G3_PFE.01","OPEN VLV_POS_TMR_05","",""},		//42
 {"CLOSE VLVG_G2_PFE.01","CLOSE VLV_IO_G3_PFE.01","CLOSE VLV_POS_TMR_05","",""},		//43
 {"OPEN VLVG_G3_PFE.01","OPEN VLV_POS.01","OPEN VLV_POS_TMR_06","",""},				//44
 {"CLOSE VLVG_G3_PFE.01","CLOSE VLV_POS.01","CLOSE VLV_POS_TMR_06","",""},			//45
 {"OPEN VLVG_G4_PFE.01","OPEN VLV_POS.02","OPEN VLV_POS_TMR_07","",""},				//46
 {"CLOSE VLVG_G4_PFE.01","CLOSE VLV_POS.02","CLOSE VLV_POS_TMR_07","",""},			//47
 {"OPEN VLVIO_G2_PFE.01","OPEN VLV_IO_G4_PFE.01","OPEN VLV_POS_TMR_08","",""},		//48
 {"CLOSE VLVIO_G2_PFE.01","CLOSE VLV_IO_G4_PFE.01","CLOSE VLV_POS_TMR_08","",""},		//49
 {"OPEN VLV_PFE_F01.07","OPEN VLV_PFE_F02.07","OPEN VLV_POS_TMR_09","",""},		//50
 {"CLOSE VLV_PFE_F01.07","CLOSE VLV_PFE_F02.07","CLOSE VLV_POS_TMR_09","",""},		//51
 {"OPEN VLVT_PFE_F01.05","OPEN VLVT_PFE_F02.05","OPEN VLV_POS_TMRB_01","",""},		//52
 {"CLOSE VLVT_PFE_F01.05","CLOSE VLVT_PFE_F02.05","CLOSE VLV_POS_TMRB_01","",""},		//53
 {"OPEN VLVT_PFE_F01.06","OPEN VLVT_PFE_F02.06","OPEN VLV_POS_TMRB_02","",""},		//54
 {"CLOSE VLVT_PFE_F01.06","CLOSE VLVT_PFE_F02.06","CLOSE VLV_POS_TMRB_02","",""},		//55
 {"OPEN VLV_PFE_F01.08","OPEN VLV_PFE_F02.08","OPEN VLV_POS_TMRB_03","OPEN VLV_POS_MAG_01",""},		//56
 {"CLOSE VLV_PFE_F01.08","CLOSE VLV_PFE_F02.08","CLOSE VLV_POS_TMRB_03","CLOSE VLV_POS_MAG_01",""},		//57
 {"OPEN VLVG_IO_PFE_F01.02","OPEN VLVG_IO_PFE_F02.02","OPEN VLV_POS_TMRB_04","OPEN VLV_POS_MAG_02",""},		//58
 {"CLOSE VLVG_IO_PFE_F01.02","CLOSE VLVG_IO_PFE_F02.02","CLOSE VLV_POS_TMRB_04","CLOSE VLV_POS_MAG_02",""},		//59
 {"OPEN VLVT_IO_PFE_F01.02","OPEN VLVT_IO_PFE_F02.02","OPEN VLV_POS_TMRB_05","OPEN VLV_POS_MAG_03",""},		//60
 {"CLOSE VLVT_IO_PFE_F01.02","CLOSE VLVT_IO_PFE_F02.02","CLOSE VLV_POS_TMRB_05","CLOSE VLV_POS_MAG_03",""},		//61
 {"OPEN VLV_PFE_F01.09","OPEN VLV_PFE_F02.09","OPEN VLV_POS_TMRB_06","OPEN VLV_POS_MAG_04",""},		//62
 {"CLOSE VLV_PFE_F01.09","CLOSE VLV_PFE_F02.09","CLOSE VLV_POS_TMRB_06","CLOSE VLV_POS_MAG_04",""},		//63
 {"OPEN VLVT_PFE_F01.07","OPEN VLVT_PFE_F02.07","OPEN VLV_POS_TMRB_07","OPEN VLV_POS_MAG_05",""},		//64
 {"CLOSE VLVT_PFE_F01.07","CLOSE VLVT_PFE_F02.07","CLOSE VLV_POS_TMRB_07","CLOSE VLV_POS_MAG_05",""},		//65
 {"OPEN VLV_PFE_F01.10","OPEN VLV_PFE_F02.10","OPEN VLV_POS_TMRA_01","OPEN VLV_POS_MAG_06",""},		//66
 {"CLOSE VLV_PFE_F01.10","CLOSE VLV_PFE_F02.10","CLOSE VLV_POS_TMRA_01","CLOSE VLV_POS_MAG_06",""},		//67
 {"OPEN VLV_POS_F01_01","OPEN VLV_POS_F02_01","OPEN VLV_POS_TMRA_02","OPEN VLV_POS_MAG_07",""},		//68
 {"CLOSE VLV_POS_F01_01","CLOSE VLV_POS_F02_01","CLOSE VLV_POS_TMRA_02","CLOSE VLV_POS_MAG_07",""},		//69
 {"OPEN VLV_POS_F01_02","OPEN VLV_POS_F02_02","OPEN VLV_POS_TMRA_03","OPEN VLV_POS_MAG_08",""},		//70
 {"CLOSE VLV_POS_F01_02","CLOSE VLV_POS_F02_02","CLOSE VLV_POS_TMRA_03","CLOSE VLV_POS_MAG_08",""},		//71
 {"OPEN SHUTTER PFE_F01.02","OPEN SHUTTER PFE_F02.02","OPEN VLV_POS_TMRA_04","","SET_%_ALLARME"},			//72
 {"CLOSE SHUTTER PFE_F01.02","CLOSE SHUTTER PFE_F02.02","CLOSE VLV_POS_TMRA_04","",""},			//73
 {"OPEN VLVG_PFE_F01.01","","OPEN VLV_POS_TMRA_05","",""},			//74
 {"CLOSE VLVG_PFE_F01.01","","CLOSE VLV_POS_TMRA_05","",""},			//75
 {"PPM1_60HZ_PFE_01","PPM1_60HZ_PFE_05","","","OPEN VLVT_PFE.01"},	//76
 {"PPM1_70HZ_PFE_01","PPM1_70HZ_PFE_05","","","CLOSE VLVT_PFE.01"},	//77
 {"PPM1_80HZ_PFE_01","PPM1_80HZ_PFE_05","","","OPEN VLVT_IO_PFE.01"},	//78
 {"PPM1_90HZ_PFE_01","PPM1_90HZ_PFE_05","","","CLOSE VLVT_IO_PFE.02"},	//79
 {"PPM1_95HZ_PFE_01","PPM1_95HZ_PFE_05","","","OPEN VLVT_PFE.02"},	//80
 {"PPM1_100HZ_PFE_01","PPM1_100HZ_PFE_05","","","CLOSE VLVT_PFE.02"},	//81
 {"PPM1_60HZ_PFE_02","PPM1_60HZ_PFE_FEL2_02","","","OPEN VLVT_PFE.03"},	//82
 {"PPM1_70HZ_PFE_02","PPM1_70HZ_PFE_FEL2_02","","","CLOSE VLVT_PFE.03"},	//83
 {"PPM1_80HZ_PFE_02","PPM1_80HZ_PFE_FEL2_02","","","OPEN VLVT_PFE.04"},	//84
 {"PPM1_90HZ_PFE_02","PPM1_90HZ_PFE_FEL2_02","","","CLOSE VLVT_PFE.04"},	//85
 {"PPM1_95HZ_PFE_02","PPM1_95HZ_PFE_FEL2_02","","","OPEN VLVT_PFE.05"},	//86
 {"PPM1_100HZ_PFE_02","PPM1_100HZ_PFE_FEL2_02","","","CLOSE VLVT_PFE.05"},	//87
 {"PPM1_60HZ_PFE_03","PPM1_60HZ_PFE_FEL2_03","","","OPEN VLVT_PFE.06"},	//88
 {"PPM1_70HZ_PFE_03","PPM1_70HZ_PFE_FEL2_03","","","CLOSE VLVT_PFE.06"},	//89
 {"PPM1_80HZ_PFE_03","PPM1_80HZ_PFE_FEL2_03","","","OPEN VLVT_IO_PFE.02"},	//90
 {"PPM1_90HZ_PFE_03","PPM1_90HZ_PFE_FEL2_03","","","CLOSE VLVT_IO_PFE.02"},	//91
 {"PPM1_95HZ_PFE_03","PPM1_95HZ_PFE_FEL2_03","","","OPEN VLVT_PFE.07"},	//92
 {"PPM1_100HZ_PFE_03","PPM1_100HZ_PFE_FEL2_03","","","CLOSE VLVT_PFE.07"},	//93
 {"PPM1_60HZ_PFE_04","PPM1_60HZ_PFE_FEL2_04","","",""},	//94
 {"PPM1_70HZ_PFE_04","PPM1_70HZ_PFE_FEL2_04","","",""},	//95
 {"PPM1_80HZ_PFE_04","PPM1_80HZ_PFE_FEL2_04","","",""},	//96
 {"PPM1_90HZ_PFE_04","PPM1_90HZ_PFE_FEL2_04","","",""},	//97
 {"PPM1_95HZ_PFE_04","PPM1_95HZ_PFE_FEL2_04","","",""},	//98
 {"PPM1_100HZ_PFE_04","PPM1_100HZ_PFE_FEL2_04","","",""},	//99
 {"PPM1_60HZ_PFE_05","PPM1_60HZ_PFE_FEL2_05","","",""},	//100
 {"PPM1_70HZ_PFE_05","PPM1_70HZ_PFE_FEL2_05","","",""},	//101
 {"PPM1_80HZ_PFE_05","PPM1_80HZ_PFE_FEL2_05","","",""},	//102
 {"PPM1_90HZ_PFE_05","PPM1_90HZ_PFE_FEL2_05","","",""},	//103
 {"PPM1_95HZ_PFE_05","PPM1_95HZ_PFE_FEL2_05","","",""},	//104
 {"PPM1_100HZ_PFE_05","PPM1_100HZ_PFE_FEL2_05","","",""},	//105
 {"PPM1_60HZ_PFE_06","PPM1_60HZ_PFE_FEL2_06","","",""},	//106
 {"PPM1_70HZ_PFE_06","PPM1_70HZ_PFE_FEL2_06","","",""},	//107
 {"PPM1_80HZ_PFE_06","PPM1_80HZ_PFE_FEL2_06","","",""},	//108
 {"PPM1_90HZ_PFE_06","PPM1_90HZ_PFE_FEL2_06","","",""},	//109
 {"PPM1_95HZ_PFE_06","PPM1_95HZ_PFE_FEL2_06","","",""},	//110
 {"PPM1_100HZ_PFE_06","PPM1_100HZ_PFE_FEL2_06","","",""},	//111
 {"PPM1_60HZ_PFE_07","PPM1_60HZ_PFE_FEL2_07","","",""},	//112
 {"PPM1_70HZ_PFE_07","PPM1_70HZ_PFE_FEL2_07","","",""},	//113
 {"PPM1_80HZ_PFE_07","PPM1_80HZ_PFE_FEL2_07","","",""},	//114
 {"PPM1_90HZ_PFE_07","PPM1_90HZ_PFE_FEL2_07","","",""},	//115
 {"PPM1_95HZ_PFE_07","PPM1_95HZ_PFE_FEL2_07","","",""},	//116
 {"PPM1_100HZ_PFE_07","PPM1_100HZ_PFE_FEL2_07","","",""},	//117
 {"PPM1_60HZ_PFE_08","PPM1_60HZ_PFE_FEL2_08","","",""},	//118
 {"PPM1_70HZ_PFE_08","PPM1_70HZ_PFE_FEL2_08","","",""},	//119
 {"PPM1_80HZ_PFE_08","PPM1_80HZ_PFE_FEL2_08","","",""},	//120
 {"PPM1_90HZ_PFE_08","PPM1_90HZ_PFE_FEL2_08","","",""},	//121
 {"PPM1_95HZ_PFE_08","PPM1_95HZ_PFE_FEL2_08","","",""},	//122
 {"PPM1_100HZ_PFE_08","PPM1_100HZ_PFE_FEL2_08","","",""},	//123
 {"STOP PPM1_PFE_01","STOP PPM1_PFE_05","","",""},	//124
 {"STOP PPM1_PFE_02","STOP PPM1_PFE_FEL2_02","","",""},	//125
 {"STOP PPM1_PFE_03","STOP PPM1_PFE_FEL2_03","","",""},	//126
 {"STOP PPM1_PFE_04","STOP PPM1_PFE_FEL2_04","","",""},	//127
 {"STOP PPM1_PFE_06","STOP PPM1_PFE_FEL2_05","","",""},	//128
 {"STOP PPM1_PFE_07","STOP PPM1_PFE_FEL2_06","","",""},	//129
 {"STOP PPM1_PFE_08","STOP PPM1_PFE_FEL2_07","","",""},	//130
 {"STOP PPM1_PFE_09","STOP PPM1_PFE_FEL2_08","","",""},	//131
 {"","","OPEN VLV_POS_TMRA_06","",""},	//132
 {"","","CLOSE VLV_POS_TMRA_06","",""},	//133
 {"","","OPEN SH_POS_01","",""},	//134
 {"","","CLOSE SH_POS_01","",""},	//135
 {"","","SET CCD_POS_TMRA_01","",""},	//136
 {"","","UNSET CCD_POS_TMRA_01","",""},	//137
 {"","","SET CCD_POS_TMRA_03","",""},	//138
 {"","","UNSET CCD_POS_TMRA_03","",""},	//139
 {"CMD ABI TMP300_PFE_F01_01 (ON)","CMD ABI TMP300_PFE_F02_01 (ON)","","",""},	//140
 {"CMD NOTABI TMP300_PFE_F01_01 (OFF)","CMD NOTABI TMP300_PFE_F02_01 (OFF)","","",""},	//141
 {"CMD ABI TMP80_PFE_F01_01 (ON)","CMD ABI TMP80_PFE_F02_01 (ON)","","",""},	//142
 {"CMD NOTABI TMP80_PFE_F01_01 (OFF)","CMD NOTABI TMP80_PFE_F02_01 (OFF)","","",""},	//143
 {"CMD ABI TMP500_PFE_F01_01 (ON)","CMD ABI TMP500_PFE_F02_01 (ON)","","",""},	//144
 {"CMD NOTABI TMP500_PFE_F01_01 (OFF)","CMD NOTABI TMP500_PFE_F02_01 (OFF)","","",""},	//145
 {"CMD ABI TMP500_PFE_F01_02 (ON)","CMD ABI TMP500_PFE_F02_02 (ON)","","",""},	//146
 {"CMD NOTABI TMP500_PFE_F01_02 (OFF)","CMD NOTABI TMP500_PFE_F02_02 (OFF)","","",""},	//147
 {"CMD LASER_POINTER_ACDC_ON","","","",""},	//148
 {"CMD LASER_POINTER_ACDC_OFF","","","",""}	//149
};

static int felcodes[] = {
	OPN_CLS_CMD_FEL1,
	OPN_CLS_CMD_FEL2,
	OPN_CLS_CMD_POS,
	OPN_CLS_CMD_MAG,
	SET_PERCENT_INTLK_THRESH,
	PMP_VEL_CMD_FEL1,
	PMP_VEL_CMD_FEL2,
	PPM_START_STOP_CMD_FEL1,
	PPM_START_STOP_CMD_FEL2
};

static const char* plc_names[] = {
 "LINAC",	//0
 "UH",		//1
 "PADRES",	//2
};


/*class plclgthread;
class plcsrvthread;*/

namespace PLCesall_ns
{
	
class plclgthread;
class plcsrvthread;
	
//timestamp size in bytes
#define	TSTAMP_SIZE	8

//#define	MESG_STAT_SYS_BLK	104
//#define	MESG_ALM_SYS_BLK	104
//#define	MESG_OUT_SYS_BLK	69
//#define	MESG_CMD_SYS_BLK	114
//size of data in bit
//#define	ALM_SIZE	MESG_STAT_SHOT_LEN*16	//because of ushort blocks


typedef struct intlck_dbstatsys {	
	u_short nDB;
	u_char		year,
			month,
			day,
			hour,
			min,
			sec,
			msec,
  			wday;
	u_char data[DB50_DATA_SIZE];
} intlck_dbstatsys_t;
typedef struct intlck_dboutsys {	
	u_short nDB;
	u_char		year,
			month,
			day,
			hour,
			min,
			sec,
			msec,
  			wday;
	u_char data[DB54_DATA_SIZE];
} intlck_dboutsys_t;
typedef struct intlck_dbalmsys {	
	u_short nDB;
	u_char		year,
			month,
			day,
			hour,
			min,
			sec,
			msec,
  			wday;
	u_char data[DB53_DATA_SIZE];
} intlck_dbalmsys_t;
typedef struct intlck_dbrealsys {	
	u_short nDB;
	u_char		year,
			month,
			day,
			hour,
			min,
			sec,
			msec,
  			wday;
	float data[DB55_DATA_SIZE];
} intlck_dbrealsys_t;
typedef struct intlck_cmd {
	u_short actDB;
	u_char		cmd[18];
	u_char		ack[288];
	u_char	year,
			month,
			day,
			hour,
			min,
			sec,
			msec,
			wday;
} intlck_cmd_t;

// timestamp
//typedef u_short tstamp_t[TSTAMP_SIZE/2];
typedef struct tstamp_s {
	u_short 	year,
			month,
			day,
			hour,
			min,
			sec,
			msec,
  			wday;
} tstamp__;

typedef struct logalarm {	
	int m_type;
	double m_tstamp;
	char* m_nm;
	char* m_msg;
} logalarm_t;

typedef struct timest_vect {
	int logtype;	
	double tstamp;
	int id_cmd;
	int id_fel;
	intlck_dbalmsys data;
} timest_vect_t;

/**
 * Class Description:
 * 
 */

/*
 *	Device States Description:
*  Tango::ON :
*  Tango::FAULT :
*  Tango::UNKNOWN :
 */


class PLCesall: public TANGO_BASE_CLASS
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attributs member data.
 */
//@{
		Tango::DevBoolean	*attr_Plc_status_read;
		Tango::DevBoolean	*attr_LogState_read;
		Tango::DevBoolean	attr_LogState_write;
		Tango::DevBoolean	*attr_Stat_system_read;
		Tango::DevBoolean	*attr_Alarm_system_read;
		Tango::DevDouble	*attr_Db_alarm_read;
		Tango::DevDouble	*attr_Db_alarm_write;
		Tango::DevBoolean	*attr_Out_system_read;
		Tango::DevDouble	*attr_Real_system_read;
//@}

/**
 *	@name Device properties
 *	Device properties member data.
 */
//@{
/**
 *	PLC connection parameters:
 *	IP
 *	port
 */
	vector<string>	connect_param;
/**
 *	PLC IP address:
 */
	string	remote_ip;
/**
 *	Cpu port:
 */
	Tango::DevLong	local_port;
/**
 *	database logging parameters:
 *	host
 *	port
 *	user
 *	pw
 */
	vector<string>	db_param;
/**
 *	Description file, list of attribute names, type, R/W and dimension
 */
	vector<string>	data_config;
/**
 *	timeout in ms, after this interval data becomes old
 */
	Tango::DevLong	timeout;
/**
	 *	0=LINAC, 1=UH, 3=PADRES
 */
	Tango::DevLong	id_plc;
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	PLCesall(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	PLCesall(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	PLCesall(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one desctructor is defined for this class */
//@{
/**
 * The object desctructor.
 */	
	~PLCesall() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method befor execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name PLCesall methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for Plc_status acquisition result.
 */
	virtual void read_Plc_status(Tango::Attribute &attr);
/**
 *	Extract real attribute values for LogState acquisition result.
 */
	virtual void read_LogState(Tango::Attribute &attr);
/**
 *	Write LogState attribute values to hardware.
 */
	virtual void write_LogState(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Stat_system acquisition result.
 */
	virtual void read_Stat_system(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Alarm_system acquisition result.
 */
	virtual void read_Alarm_system(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Db_alarm acquisition result.
 */
	virtual void read_Db_alarm(Tango::Attribute &attr);
/**
 *	Write Db_alarm attribute values to hardware.
 */
	virtual void write_Db_alarm(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Out_system acquisition result.
 */
	virtual void read_Out_system(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Real_system acquisition result.
 */
	virtual void read_Real_system(Tango::Attribute &attr);
/**
 *	Read/Write allowed for Plc_status attribute.
 */
	virtual bool is_Plc_status_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for LogState attribute.
 */
	virtual bool is_LogState_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Stat_system attribute.
 */
	virtual bool is_Stat_system_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Alarm_system attribute.
 */
	virtual bool is_Alarm_system_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Db_alarm attribute.
 */
	virtual bool is_Db_alarm_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Out_system attribute.
 */
	virtual bool is_Out_system_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Real_system attribute.
 */
	virtual bool is_Real_system_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for Send_cmd command.
 */
	virtual bool is_Send_cmd_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for Acknowledge command.
 */
	virtual bool is_Acknowledge_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for UpdateDBDescription command.
 */
	virtual bool is_UpdateDBDescription_allowed(const CORBA::Any &any);
/**
 * 
 *	@param	argin	Command code, cmd argument
 *	@exception DevFailed
 */
	void	send_cmd(const Tango::DevVarShortArray *);
/**
 * 
 *	@param	argin	
 *	@exception DevFailed
 */
	void	acknowledge(const Tango::DevVarShortArray *);
/**
 * 
 *	@param	argin	
 *	@exception DevFailed
 */
	void	update_db_description();

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	
	bool abortflag;  // flag used to abort thread loops 	
	int new_sd, sock;	// socket for data exchange
	ifstream  fd;		//startup file
	string 	start_file;
	plcsrvthread *srvloop;	//read from socket thread
	plclgthread *logloop;	//manages the read timeout

	MYSQL dbp;

	Tango::DevShort	pport;
	string	ipaddr;
	string srv_host;
	Tango::DevBoolean plc_status;

	string				att_names[MAX_N_ATTR];
	Tango::DevShort		att_len[MAX_N_ATTR];
	string*				val_labels[MAX_N_ATTR];
	string*				val_pos[MAX_N_ATTR];

	tstamp_s tst_stat;
	tstamp_s old_tst_stat;
	double timestamp_alm;
	double timestamp_stat;
	double timestamp_last;
	Tango::DevBoolean	msg_statsys[MESG_STAT_SYS_LEN];
	Tango::DevBoolean	msg_almsys[MESG_ALM_SYS_LEN];
	Tango::DevBoolean	msg_outsys[MESG_OUT_SYS_LEN];
	float	msg_realsys[MESG_REAL_SYS_LEN];
	intlck_dbstatsys message_statsys;	
	intlck_dbalmsys message_almsys;	
	intlck_dboutsys message_outsys;
	intlck_dbrealsys message_realsys;

	Tango::DevDouble	alarm_db[MESG_ALM_SYS_LEN];
	Tango::DevDouble	w_alarm_db[MESG_ALM_SYS_LEN];
	Tango::DevBoolean	alm_active[MESG_ALM_SYS_LEN];//if false the alarm is ignored during logging
	Tango::DevBoolean	old_alm[MESG_ALM_SYS_LEN];

	intlck_cmd prepared_cmd;

	void	syncronize();
	void load_cond(void);//load bit info from file
	void init_attributeprop(void);//init attribute properties
	void init_database(void);
	long int calc_timeval(u_char,u_char,u_char,u_char,u_char,u_char,u_char,u_char);
	long int calc_time_ms(u_char,u_char);
	uint16_t plc_swap(uint16_t in);

	Tango::DevBoolean	logstate;
	string LOG_DB_NAME;
void write_msg(void);
protected :	
	//	Add your own data members here
	//-----------------------------------------
	//omni_thread	*plc_thread;
	Tango::DeviceProxy * Socketds;
	//void write_msg(void);
	void send_frame (unsigned char *query, short query_length);
};

}	// namespace_ns

#endif	// _PLCESALL_H
