/*
 * plcsrvthread.h
 *
 *	06.07.2010 - GZS: first release 
 *	 
 */ 

#ifndef PLCSRVTHREAD_H
#define PLCSRVTHREAD_H

#include <omnithread.h>
#include <tango.h>
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>    
#include <string.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <arpa/inet.h>
#include <signal.h>
#include <netdb.h>    

#include <PLCesall.h>

//number of socket accepted by the server
const short MAX_NUM_SOCK=1; 
#define MASK_BIT0     0x0001
#define MASK_BIT1     0x0002
#define MASK_BIT2     0x0004
#define MASK_BIT3     0x0008
#define MASK_BIT4     0x0010
#define MASK_BIT5     0x0020
#define MASK_BIT6     0x0040
#define MASK_BIT7     0x0080
#define MASK_BIT8     0x0100
#define MASK_BIT9     0x0200
#define MASK_BIT10     0x0400
#define MASK_BIT11     0x0800
#define MASK_BIT12     0x1000
#define MASK_BIT13     0x2000
#define MASK_BIT14     0x4000
#define MASK_BIT15     0x8000


static int bmask[] = {
	MASK_BIT0, 
	MASK_BIT1, 
	MASK_BIT2, 
	MASK_BIT3, 
	MASK_BIT4, 
	MASK_BIT5, 
	MASK_BIT6, 
	MASK_BIT7, 
	MASK_BIT8, 
	MASK_BIT9, 
	MASK_BIT10, 
	MASK_BIT11, 
	MASK_BIT12, 
	MASK_BIT13, 
	MASK_BIT14, 
	MASK_BIT15
};


namespace PLCesall_ns{


class plcsrvthread : public omni_thread, public Tango::LogAdapter{
	
	private:
		PLCesall_ns::PLCesall *t_PLCesall;		
				
	public:
		
		plcsrvthread(PLCesall_ns::PLCesall *s):Tango::LogAdapter(s){
			t_PLCesall = s;
			first_mesg = true;
		};
		
		~plcsrvthread() {
		};
//		void *StartUndetached(){
//			start_undetached();
//		}
//		void *run_undetached(void *);	

	protected:
		void run(void *);	
	
		int errcount;
		struct timeval _pre, _post;
		char frame2[BUF_LEN];
		u_short olddata;
	//	PLCesall_ns::tstamp_t time_before;
	//	PLCesall_ns::intlck_db53 lastmsg;

		Tango::DeviceProxy *mydevice;
		Tango::DeviceAttribute arl;
	
	//	PLCesall_ns::logalarm_t local_mesg;
	
		int cnt, cnt2, server_started;
		bool first_mesg;
	      
		struct sockaddr_in myname;  
		struct sockaddr_in *nptr;   
		struct sockaddr    addr;    

   	//	struct sembuf operations[1];
   		int retval;
   		int id;
   
		//unsigned char buf[BUF_LEN];
		char *buf;

		void Srv_Prepare(void);
		uint16_t plc_swap(uint16_t in);
		uint32_t plc_swaplong(uint32_t in);

		long ll, mm;
		u_short v;
		int brk;

		void info_msg(void);
		void stat_msg(void);
		void alm_msg(void);
		void out_msg(void);
		void real_msg(void);
		
		float ntohf(float val_f);
		float htonf(float val_f);

		int idx;				
};	/* end class plcsrvthread() */

}//	namespace 

#endif

/* EOF */
